import { v4 } from 'uuid';
import deepEqual4 from 'deep-equal';
import { deepmerge } from 'deepmerge-ts';
import { setProperty, getProperty, deleteProperty } from 'dot-prop';
import createClient from 'openapi-fetch';
import * as levenshtein from 'fast-levenshtein';
import decodeJwt from 'jwt-decode';
import pino from 'pino';
import { LRUCache } from 'lru-cache';
import hashObject from 'object-hash';
import { Univariate } from 'stats-logscale';

var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name3 in all)
    __defProp(target, name3, { get: all[name3], enumerable: true });
};

// ../../node_modules/@jspm/core/nodelibs/browser/process.js
var process_exports = {};
__export(process_exports, {
  _debugEnd: () => _debugEnd,
  _debugProcess: () => _debugProcess,
  _events: () => _events,
  _eventsCount: () => _eventsCount,
  _exiting: () => _exiting,
  _fatalExceptions: () => _fatalExceptions,
  _getActiveHandles: () => _getActiveHandles,
  _getActiveRequests: () => _getActiveRequests,
  _kill: () => _kill,
  _linkedBinding: () => _linkedBinding,
  _maxListeners: () => _maxListeners,
  _preload_modules: () => _preload_modules,
  _rawDebug: () => _rawDebug,
  _startProfilerIdleNotifier: () => _startProfilerIdleNotifier,
  _stopProfilerIdleNotifier: () => _stopProfilerIdleNotifier,
  _tickCallback: () => _tickCallback,
  abort: () => abort,
  addListener: () => addListener,
  allowedNodeEnvironmentFlags: () => allowedNodeEnvironmentFlags,
  arch: () => arch,
  argv: () => argv,
  argv0: () => argv0,
  assert: () => assert,
  binding: () => binding,
  chdir: () => chdir,
  config: () => config,
  cpuUsage: () => cpuUsage,
  cwd: () => cwd,
  debugPort: () => debugPort,
  default: () => process,
  dlopen: () => dlopen,
  domain: () => domain,
  emit: () => emit,
  emitWarning: () => emitWarning,
  env: () => env,
  execArgv: () => execArgv,
  execPath: () => execPath,
  exit: () => exit,
  features: () => features,
  hasUncaughtExceptionCaptureCallback: () => hasUncaughtExceptionCaptureCallback,
  hrtime: () => hrtime,
  kill: () => kill,
  listeners: () => listeners,
  memoryUsage: () => memoryUsage,
  moduleLoadList: () => moduleLoadList,
  nextTick: () => nextTick,
  off: () => off,
  on: () => on,
  once: () => once,
  openStdin: () => openStdin,
  pid: () => pid,
  platform: () => platform,
  ppid: () => ppid,
  prependListener: () => prependListener,
  prependOnceListener: () => prependOnceListener,
  reallyExit: () => reallyExit,
  release: () => release,
  removeAllListeners: () => removeAllListeners,
  removeListener: () => removeListener,
  resourceUsage: () => resourceUsage,
  setSourceMapsEnabled: () => setSourceMapsEnabled,
  setUncaughtExceptionCaptureCallback: () => setUncaughtExceptionCaptureCallback,
  stderr: () => stderr,
  stdin: () => stdin,
  stdout: () => stdout,
  title: () => title,
  umask: () => umask,
  uptime: () => uptime,
  version: () => version,
  versions: () => versions
});
function unimplemented(name3) {
  throw new Error("Node.js process " + name3 + " is not supported by JSPM core outside of Node.js");
}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;
function cleanUpNextTick() {
  if (!draining || !currentQueue)
    return;
  draining = false;
  if (currentQueue.length) {
    queue = currentQueue.concat(queue);
  } else {
    queueIndex = -1;
  }
  if (queue.length)
    drainQueue();
}
function drainQueue() {
  if (draining)
    return;
  var timeout = setTimeout(cleanUpNextTick, 0);
  draining = true;
  var len = queue.length;
  while (len) {
    currentQueue = queue;
    queue = [];
    while (++queueIndex < len) {
      if (currentQueue)
        currentQueue[queueIndex].run();
    }
    queueIndex = -1;
    len = queue.length;
  }
  currentQueue = null;
  draining = false;
  clearTimeout(timeout);
}
function nextTick(fun) {
  var args = new Array(arguments.length - 1);
  if (arguments.length > 1) {
    for (var i2 = 1; i2 < arguments.length; i2++)
      args[i2 - 1] = arguments[i2];
  }
  queue.push(new Item(fun, args));
  if (queue.length === 1 && !draining)
    setTimeout(drainQueue, 0);
}
function Item(fun, array) {
  this.fun = fun;
  this.array = array;
}
Item.prototype.run = function() {
  this.fun.apply(null, this.array);
};
var title = "browser";
var arch = "x64";
var platform = "browser";
var env = {
  PATH: "/usr/bin",
  LANG: navigator.language + ".UTF-8",
  PWD: "/",
  HOME: "/home",
  TMP: "/tmp"
};
var argv = ["/usr/bin/node"];
var execArgv = [];
var version = "v16.8.0";
var versions = {};
var emitWarning = function(message, type2) {
  console.warn((type2 ? type2 + ": " : "") + message);
};
var binding = function(name3) {
  unimplemented("binding");
};
var umask = function(mask) {
  return 0;
};
var cwd = function() {
  return "/";
};
var chdir = function(dir) {
};
var release = {
  name: "node",
  sourceUrl: "",
  headersUrl: "",
  libUrl: ""
};
function noop() {
}
var _rawDebug = noop;
var moduleLoadList = [];
function _linkedBinding(name3) {
  unimplemented("_linkedBinding");
}
var domain = {};
var _exiting = false;
var config = {};
function dlopen(name3) {
  unimplemented("dlopen");
}
function _getActiveRequests() {
  return [];
}
function _getActiveHandles() {
  return [];
}
var reallyExit = noop;
var _kill = noop;
var cpuUsage = function() {
  return {};
};
var resourceUsage = cpuUsage;
var memoryUsage = cpuUsage;
var kill = noop;
var exit = noop;
var openStdin = noop;
var allowedNodeEnvironmentFlags = {};
function assert(condition, message) {
  if (!condition)
    throw new Error(message || "assertion error");
}
var features = {
  inspector: false,
  debug: false,
  uv: false,
  ipv6: false,
  tls_alpn: false,
  tls_sni: false,
  tls_ocsp: false,
  tls: false,
  cached_builtins: true
};
var _fatalExceptions = noop;
var setUncaughtExceptionCaptureCallback = noop;
function hasUncaughtExceptionCaptureCallback() {
  return false;
}
var _tickCallback = noop;
var _debugProcess = noop;
var _debugEnd = noop;
var _startProfilerIdleNotifier = noop;
var _stopProfilerIdleNotifier = noop;
var stdout = void 0;
var stderr = void 0;
var stdin = void 0;
var abort = noop;
var pid = 2;
var ppid = 1;
var execPath = "/bin/usr/node";
var debugPort = 9229;
var argv0 = "node";
var _preload_modules = [];
var setSourceMapsEnabled = noop;
var _performance = {
  now: typeof performance !== "undefined" ? performance.now.bind(performance) : void 0,
  timing: typeof performance !== "undefined" ? performance.timing : void 0
};
if (_performance.now === void 0) {
  nowOffset = Date.now();
  if (_performance.timing && _performance.timing.navigationStart) {
    nowOffset = _performance.timing.navigationStart;
  }
  _performance.now = () => Date.now() - nowOffset;
}
var nowOffset;
function uptime() {
  return _performance.now() / 1e3;
}
var nanoPerSec = 1e9;
function hrtime(previousTimestamp) {
  var baseNow = Math.floor((Date.now() - _performance.now()) * 1e-3);
  var clocktime = _performance.now() * 1e-3;
  var seconds = Math.floor(clocktime) + baseNow;
  var nanoseconds = Math.floor(clocktime % 1 * 1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds < 0) {
      seconds--;
      nanoseconds += nanoPerSec;
    }
  }
  return [seconds, nanoseconds];
}
hrtime.bigint = function(time) {
  var diff = hrtime(time);
  if (typeof BigInt === "undefined") {
    return diff[0] * nanoPerSec + diff[1];
  }
  return BigInt(diff[0] * nanoPerSec) + BigInt(diff[1]);
};
var _maxListeners = 10;
var _events = {};
var _eventsCount = 0;
function on() {
  return process;
}
var addListener = on;
var once = on;
var off = on;
var removeListener = on;
var removeAllListeners = on;
var emit = noop;
var prependListener = on;
var prependOnceListener = on;
function listeners(name3) {
  return [];
}
var process = {
  version,
  versions,
  arch,
  platform,
  release,
  _rawDebug,
  moduleLoadList,
  binding,
  _linkedBinding,
  _events,
  _eventsCount,
  _maxListeners,
  on,
  addListener,
  once,
  off,
  removeListener,
  removeAllListeners,
  emit,
  prependListener,
  prependOnceListener,
  listeners,
  domain,
  _exiting,
  config,
  dlopen,
  uptime,
  _getActiveRequests,
  _getActiveHandles,
  reallyExit,
  _kill,
  cpuUsage,
  resourceUsage,
  memoryUsage,
  kill,
  exit,
  openStdin,
  allowedNodeEnvironmentFlags,
  assert,
  features,
  _fatalExceptions,
  setUncaughtExceptionCaptureCallback,
  hasUncaughtExceptionCaptureCallback,
  emitWarning,
  nextTick,
  _tickCallback,
  _debugProcess,
  _debugEnd,
  _startProfilerIdleNotifier,
  _stopProfilerIdleNotifier,
  stdout,
  stdin,
  stderr,
  abort,
  umask,
  chdir,
  cwd,
  env,
  title,
  argv,
  execArgv,
  pid,
  ppid,
  execPath,
  debugPort,
  hrtime,
  argv0,
  _preload_modules,
  setSourceMapsEnabled
};

// ../../node_modules/@jspm/core/nodelibs/browser/chunk-4bd36a8f.js
var e;
var t;
var n = "object" == typeof Reflect ? Reflect : null;
var r = n && "function" == typeof n.apply ? n.apply : function(e2, t2, n2) {
  return Function.prototype.apply.call(e2, t2, n2);
};
t = n && "function" == typeof n.ownKeys ? n.ownKeys : Object.getOwnPropertySymbols ? function(e2) {
  return Object.getOwnPropertyNames(e2).concat(Object.getOwnPropertySymbols(e2));
} : function(e2) {
  return Object.getOwnPropertyNames(e2);
};
var i = Number.isNaN || function(e2) {
  return e2 != e2;
};
function o() {
  o.init.call(this);
}
e = o, o.EventEmitter = o, o.prototype._events = void 0, o.prototype._eventsCount = 0, o.prototype._maxListeners = void 0;
var s = 10;
function u(e2) {
  if ("function" != typeof e2)
    throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e2);
}
function f(e2) {
  return void 0 === e2._maxListeners ? o.defaultMaxListeners : e2._maxListeners;
}
function v(e2, t2, n2, r2) {
  var i2, o2, s2, v2;
  if (u(n2), void 0 === (o2 = e2._events) ? (o2 = e2._events = /* @__PURE__ */ Object.create(null), e2._eventsCount = 0) : (void 0 !== o2.newListener && (e2.emit("newListener", t2, n2.listener ? n2.listener : n2), o2 = e2._events), s2 = o2[t2]), void 0 === s2)
    s2 = o2[t2] = n2, ++e2._eventsCount;
  else if ("function" == typeof s2 ? s2 = o2[t2] = r2 ? [n2, s2] : [s2, n2] : r2 ? s2.unshift(n2) : s2.push(n2), (i2 = f(e2)) > 0 && s2.length > i2 && !s2.warned) {
    s2.warned = true;
    var a2 = new Error("Possible EventEmitter memory leak detected. " + s2.length + " " + String(t2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
    a2.name = "MaxListenersExceededWarning", a2.emitter = e2, a2.type = t2, a2.count = s2.length, v2 = a2, console && console.warn && console.warn(v2);
  }
  return e2;
}
function a() {
  if (!this.fired)
    return this.target.removeListener(this.type, this.wrapFn), this.fired = true, 0 === arguments.length ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
}
function l(e2, t2, n2) {
  var r2 = { fired: false, wrapFn: void 0, target: e2, type: t2, listener: n2 }, i2 = a.bind(r2);
  return i2.listener = n2, r2.wrapFn = i2, i2;
}
function h(e2, t2, n2) {
  var r2 = e2._events;
  if (void 0 === r2)
    return [];
  var i2 = r2[t2];
  return void 0 === i2 ? [] : "function" == typeof i2 ? n2 ? [i2.listener || i2] : [i2] : n2 ? function(e3) {
    for (var t3 = new Array(e3.length), n3 = 0; n3 < t3.length; ++n3)
      t3[n3] = e3[n3].listener || e3[n3];
    return t3;
  }(i2) : c(i2, i2.length);
}
function p(e2) {
  var t2 = this._events;
  if (void 0 !== t2) {
    var n2 = t2[e2];
    if ("function" == typeof n2)
      return 1;
    if (void 0 !== n2)
      return n2.length;
  }
  return 0;
}
function c(e2, t2) {
  for (var n2 = new Array(t2), r2 = 0; r2 < t2; ++r2)
    n2[r2] = e2[r2];
  return n2;
}
Object.defineProperty(o, "defaultMaxListeners", { enumerable: true, get: function() {
  return s;
}, set: function(e2) {
  if ("number" != typeof e2 || e2 < 0 || i(e2))
    throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e2 + ".");
  s = e2;
} }), o.init = function() {
  void 0 !== this._events && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
}, o.prototype.setMaxListeners = function(e2) {
  if ("number" != typeof e2 || e2 < 0 || i(e2))
    throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e2 + ".");
  return this._maxListeners = e2, this;
}, o.prototype.getMaxListeners = function() {
  return f(this);
}, o.prototype.emit = function(e2) {
  for (var t2 = [], n2 = 1; n2 < arguments.length; n2++)
    t2.push(arguments[n2]);
  var i2 = "error" === e2, o2 = this._events;
  if (void 0 !== o2)
    i2 = i2 && void 0 === o2.error;
  else if (!i2)
    return false;
  if (i2) {
    var s2;
    if (t2.length > 0 && (s2 = t2[0]), s2 instanceof Error)
      throw s2;
    var u2 = new Error("Unhandled error." + (s2 ? " (" + s2.message + ")" : ""));
    throw u2.context = s2, u2;
  }
  var f2 = o2[e2];
  if (void 0 === f2)
    return false;
  if ("function" == typeof f2)
    r(f2, this, t2);
  else {
    var v2 = f2.length, a2 = c(f2, v2);
    for (n2 = 0; n2 < v2; ++n2)
      r(a2[n2], this, t2);
  }
  return true;
}, o.prototype.addListener = function(e2, t2) {
  return v(this, e2, t2, false);
}, o.prototype.on = o.prototype.addListener, o.prototype.prependListener = function(e2, t2) {
  return v(this, e2, t2, true);
}, o.prototype.once = function(e2, t2) {
  return u(t2), this.on(e2, l(this, e2, t2)), this;
}, o.prototype.prependOnceListener = function(e2, t2) {
  return u(t2), this.prependListener(e2, l(this, e2, t2)), this;
}, o.prototype.removeListener = function(e2, t2) {
  var n2, r2, i2, o2, s2;
  if (u(t2), void 0 === (r2 = this._events))
    return this;
  if (void 0 === (n2 = r2[e2]))
    return this;
  if (n2 === t2 || n2.listener === t2)
    0 == --this._eventsCount ? this._events = /* @__PURE__ */ Object.create(null) : (delete r2[e2], r2.removeListener && this.emit("removeListener", e2, n2.listener || t2));
  else if ("function" != typeof n2) {
    for (i2 = -1, o2 = n2.length - 1; o2 >= 0; o2--)
      if (n2[o2] === t2 || n2[o2].listener === t2) {
        s2 = n2[o2].listener, i2 = o2;
        break;
      }
    if (i2 < 0)
      return this;
    0 === i2 ? n2.shift() : !function(e3, t3) {
      for (; t3 + 1 < e3.length; t3++)
        e3[t3] = e3[t3 + 1];
      e3.pop();
    }(n2, i2), 1 === n2.length && (r2[e2] = n2[0]), void 0 !== r2.removeListener && this.emit("removeListener", e2, s2 || t2);
  }
  return this;
}, o.prototype.off = o.prototype.removeListener, o.prototype.removeAllListeners = function(e2) {
  var t2, n2, r2;
  if (void 0 === (n2 = this._events))
    return this;
  if (void 0 === n2.removeListener)
    return 0 === arguments.length ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : void 0 !== n2[e2] && (0 == --this._eventsCount ? this._events = /* @__PURE__ */ Object.create(null) : delete n2[e2]), this;
  if (0 === arguments.length) {
    var i2, o2 = Object.keys(n2);
    for (r2 = 0; r2 < o2.length; ++r2)
      "removeListener" !== (i2 = o2[r2]) && this.removeAllListeners(i2);
    return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
  }
  if ("function" == typeof (t2 = n2[e2]))
    this.removeListener(e2, t2);
  else if (void 0 !== t2)
    for (r2 = t2.length - 1; r2 >= 0; r2--)
      this.removeListener(e2, t2[r2]);
  return this;
}, o.prototype.listeners = function(e2) {
  return h(this, e2, true);
}, o.prototype.rawListeners = function(e2) {
  return h(this, e2, false);
}, o.listenerCount = function(e2, t2) {
  return "function" == typeof e2.listenerCount ? e2.listenerCount(t2) : p.call(e2, t2);
}, o.prototype.listenerCount = p, o.prototype.eventNames = function() {
  return this._eventsCount > 0 ? t(this._events) : [];
};
var y = e;

// ../../node_modules/@jspm/core/nodelibs/browser/events.js
y.once = function(emitter, event) {
  return new Promise((resolve2, reject) => {
    function eventListener(...args) {
      if (errorListener !== void 0) {
        emitter.removeListener("error", errorListener);
      }
      resolve2(args);
    }
    let errorListener;
    if (event !== "error") {
      errorListener = (err) => {
        emitter.removeListener(name, eventListener);
        reject(err);
      };
      emitter.once("error", errorListener);
    }
    emitter.once(event, eventListener);
  });
};
y.on = function(emitter, event) {
  const unconsumedEventValues = [];
  const unconsumedPromises = [];
  let error = null;
  let finished = false;
  const iterator = {
    async next() {
      const value = unconsumedEventValues.shift();
      if (value) {
        return createIterResult(value, false);
      }
      if (error) {
        const p2 = Promise.reject(error);
        error = null;
        return p2;
      }
      if (finished) {
        return createIterResult(void 0, true);
      }
      return new Promise((resolve2, reject) => unconsumedPromises.push({ resolve: resolve2, reject }));
    },
    async return() {
      emitter.removeListener(event, eventHandler);
      emitter.removeListener("error", errorHandler);
      finished = true;
      for (const promise of unconsumedPromises) {
        promise.resolve(createIterResult(void 0, true));
      }
      return createIterResult(void 0, true);
    },
    throw(err) {
      error = err;
      emitter.removeListener(event, eventHandler);
      emitter.removeListener("error", errorHandler);
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  };
  emitter.on(event, eventHandler);
  emitter.on("error", errorHandler);
  return iterator;
  function eventHandler(...args) {
    const promise = unconsumedPromises.shift();
    if (promise) {
      promise.resolve(createIterResult(args, false));
    } else {
      unconsumedEventValues.push(args);
    }
  }
  function errorHandler(err) {
    finished = true;
    const toError = unconsumedPromises.shift();
    if (toError) {
      toError.reject(err);
    } else {
      error = err;
    }
    iterator.return();
  }
};
var {
  EventEmitter,
  defaultMaxListeners,
  init,
  listenerCount,
  on: on2,
  once: once2
} = y;

// ../../node_modules/@jspm/core/nodelibs/browser/chunk-2eac56ff.js
var exports = {};
var _dewExec = false;
var _global = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : global;
function dew() {
  if (_dewExec)
    return exports;
  _dewExec = true;
  var process3 = exports = {};
  var cachedSetTimeout;
  var cachedClearTimeout;
  function defaultSetTimout() {
    throw new Error("setTimeout has not been defined");
  }
  function defaultClearTimeout() {
    throw new Error("clearTimeout has not been defined");
  }
  (function() {
    try {
      if (typeof setTimeout === "function") {
        cachedSetTimeout = setTimeout;
      } else {
        cachedSetTimeout = defaultSetTimout;
      }
    } catch (e2) {
      cachedSetTimeout = defaultSetTimout;
    }
    try {
      if (typeof clearTimeout === "function") {
        cachedClearTimeout = clearTimeout;
      } else {
        cachedClearTimeout = defaultClearTimeout;
      }
    } catch (e2) {
      cachedClearTimeout = defaultClearTimeout;
    }
  })();
  function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
      return setTimeout(fun, 0);
    }
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
      cachedSetTimeout = setTimeout;
      return setTimeout(fun, 0);
    }
    try {
      return cachedSetTimeout(fun, 0);
    } catch (e2) {
      try {
        return cachedSetTimeout.call(null, fun, 0);
      } catch (e3) {
        return cachedSetTimeout.call(this || _global, fun, 0);
      }
    }
  }
  function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
      return clearTimeout(marker);
    }
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
      cachedClearTimeout = clearTimeout;
      return clearTimeout(marker);
    }
    try {
      return cachedClearTimeout(marker);
    } catch (e2) {
      try {
        return cachedClearTimeout.call(null, marker);
      } catch (e3) {
        return cachedClearTimeout.call(this || _global, marker);
      }
    }
  }
  var queue2 = [];
  var draining2 = false;
  var currentQueue2;
  var queueIndex2 = -1;
  function cleanUpNextTick2() {
    if (!draining2 || !currentQueue2) {
      return;
    }
    draining2 = false;
    if (currentQueue2.length) {
      queue2 = currentQueue2.concat(queue2);
    } else {
      queueIndex2 = -1;
    }
    if (queue2.length) {
      drainQueue2();
    }
  }
  function drainQueue2() {
    if (draining2) {
      return;
    }
    var timeout = runTimeout(cleanUpNextTick2);
    draining2 = true;
    var len = queue2.length;
    while (len) {
      currentQueue2 = queue2;
      queue2 = [];
      while (++queueIndex2 < len) {
        if (currentQueue2) {
          currentQueue2[queueIndex2].run();
        }
      }
      queueIndex2 = -1;
      len = queue2.length;
    }
    currentQueue2 = null;
    draining2 = false;
    runClearTimeout(timeout);
  }
  process3.nextTick = function(fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
      for (var i2 = 1; i2 < arguments.length; i2++) {
        args[i2 - 1] = arguments[i2];
      }
    }
    queue2.push(new Item2(fun, args));
    if (queue2.length === 1 && !draining2) {
      runTimeout(drainQueue2);
    }
  };
  function Item2(fun, array) {
    (this || _global).fun = fun;
    (this || _global).array = array;
  }
  Item2.prototype.run = function() {
    (this || _global).fun.apply(null, (this || _global).array);
  };
  process3.title = "browser";
  process3.browser = true;
  process3.env = {};
  process3.argv = [];
  process3.version = "";
  process3.versions = {};
  function noop2() {
  }
  process3.on = noop2;
  process3.addListener = noop2;
  process3.once = noop2;
  process3.off = noop2;
  process3.removeListener = noop2;
  process3.removeAllListeners = noop2;
  process3.emit = noop2;
  process3.prependListener = noop2;
  process3.prependOnceListener = noop2;
  process3.listeners = function(name3) {
    return [];
  };
  process3.binding = function(name3) {
    throw new Error("process.binding is not supported");
  };
  process3.cwd = function() {
    return "/";
  };
  process3.chdir = function(dir) {
    throw new Error("process.chdir is not supported");
  };
  process3.umask = function() {
    return 0;
  };
  return exports;
}
var process2 = dew();
process2.platform = "browser";

// ../../node_modules/@jspm/core/nodelibs/browser/chunk-23dbec7b.js
var exports$1 = {};
var _dewExec2 = false;
function dew2() {
  if (_dewExec2)
    return exports$1;
  _dewExec2 = true;
  var process$1 = process2;
  function assertPath(path) {
    if (typeof path !== "string") {
      throw new TypeError("Path must be a string. Received " + JSON.stringify(path));
    }
  }
  function normalizeStringPosix(path, allowAboveRoot) {
    var res = "";
    var lastSegmentLength = 0;
    var lastSlash = -1;
    var dots = 0;
    var code;
    for (var i2 = 0; i2 <= path.length; ++i2) {
      if (i2 < path.length)
        code = path.charCodeAt(i2);
      else if (code === 47)
        break;
      else
        code = 47;
      if (code === 47) {
        if (lastSlash === i2 - 1 || dots === 1)
          ;
        else if (lastSlash !== i2 - 1 && dots === 2) {
          if (res.length < 2 || lastSegmentLength !== 2 || res.charCodeAt(res.length - 1) !== 46 || res.charCodeAt(res.length - 2) !== 46) {
            if (res.length > 2) {
              var lastSlashIndex = res.lastIndexOf("/");
              if (lastSlashIndex !== res.length - 1) {
                if (lastSlashIndex === -1) {
                  res = "";
                  lastSegmentLength = 0;
                } else {
                  res = res.slice(0, lastSlashIndex);
                  lastSegmentLength = res.length - 1 - res.lastIndexOf("/");
                }
                lastSlash = i2;
                dots = 0;
                continue;
              }
            } else if (res.length === 2 || res.length === 1) {
              res = "";
              lastSegmentLength = 0;
              lastSlash = i2;
              dots = 0;
              continue;
            }
          }
          if (allowAboveRoot) {
            if (res.length > 0)
              res += "/..";
            else
              res = "..";
            lastSegmentLength = 2;
          }
        } else {
          if (res.length > 0)
            res += "/" + path.slice(lastSlash + 1, i2);
          else
            res = path.slice(lastSlash + 1, i2);
          lastSegmentLength = i2 - lastSlash - 1;
        }
        lastSlash = i2;
        dots = 0;
      } else if (code === 46 && dots !== -1) {
        ++dots;
      } else {
        dots = -1;
      }
    }
    return res;
  }
  function _format(sep2, pathObject) {
    var dir = pathObject.dir || pathObject.root;
    var base = pathObject.base || (pathObject.name || "") + (pathObject.ext || "");
    if (!dir) {
      return base;
    }
    if (dir === pathObject.root) {
      return dir + base;
    }
    return dir + sep2 + base;
  }
  var posix2 = {
    // path.resolve([from ...], to)
    resolve: function resolve2() {
      var resolvedPath = "";
      var resolvedAbsolute = false;
      var cwd2;
      for (var i2 = arguments.length - 1; i2 >= -1 && !resolvedAbsolute; i2--) {
        var path;
        if (i2 >= 0)
          path = arguments[i2];
        else {
          if (cwd2 === void 0)
            cwd2 = process$1.cwd();
          path = cwd2;
        }
        assertPath(path);
        if (path.length === 0) {
          continue;
        }
        resolvedPath = path + "/" + resolvedPath;
        resolvedAbsolute = path.charCodeAt(0) === 47;
      }
      resolvedPath = normalizeStringPosix(resolvedPath, !resolvedAbsolute);
      if (resolvedAbsolute) {
        if (resolvedPath.length > 0)
          return "/" + resolvedPath;
        else
          return "/";
      } else if (resolvedPath.length > 0) {
        return resolvedPath;
      } else {
        return ".";
      }
    },
    normalize: function normalize2(path) {
      assertPath(path);
      if (path.length === 0)
        return ".";
      var isAbsolute2 = path.charCodeAt(0) === 47;
      var trailingSeparator = path.charCodeAt(path.length - 1) === 47;
      path = normalizeStringPosix(path, !isAbsolute2);
      if (path.length === 0 && !isAbsolute2)
        path = ".";
      if (path.length > 0 && trailingSeparator)
        path += "/";
      if (isAbsolute2)
        return "/" + path;
      return path;
    },
    isAbsolute: function isAbsolute2(path) {
      assertPath(path);
      return path.length > 0 && path.charCodeAt(0) === 47;
    },
    join: function join2() {
      if (arguments.length === 0)
        return ".";
      var joined;
      for (var i2 = 0; i2 < arguments.length; ++i2) {
        var arg = arguments[i2];
        assertPath(arg);
        if (arg.length > 0) {
          if (joined === void 0)
            joined = arg;
          else
            joined += "/" + arg;
        }
      }
      if (joined === void 0)
        return ".";
      return posix2.normalize(joined);
    },
    relative: function relative2(from, to) {
      assertPath(from);
      assertPath(to);
      if (from === to)
        return "";
      from = posix2.resolve(from);
      to = posix2.resolve(to);
      if (from === to)
        return "";
      var fromStart = 1;
      for (; fromStart < from.length; ++fromStart) {
        if (from.charCodeAt(fromStart) !== 47)
          break;
      }
      var fromEnd = from.length;
      var fromLen = fromEnd - fromStart;
      var toStart = 1;
      for (; toStart < to.length; ++toStart) {
        if (to.charCodeAt(toStart) !== 47)
          break;
      }
      var toEnd = to.length;
      var toLen = toEnd - toStart;
      var length = fromLen < toLen ? fromLen : toLen;
      var lastCommonSep = -1;
      var i2 = 0;
      for (; i2 <= length; ++i2) {
        if (i2 === length) {
          if (toLen > length) {
            if (to.charCodeAt(toStart + i2) === 47) {
              return to.slice(toStart + i2 + 1);
            } else if (i2 === 0) {
              return to.slice(toStart + i2);
            }
          } else if (fromLen > length) {
            if (from.charCodeAt(fromStart + i2) === 47) {
              lastCommonSep = i2;
            } else if (i2 === 0) {
              lastCommonSep = 0;
            }
          }
          break;
        }
        var fromCode = from.charCodeAt(fromStart + i2);
        var toCode = to.charCodeAt(toStart + i2);
        if (fromCode !== toCode)
          break;
        else if (fromCode === 47)
          lastCommonSep = i2;
      }
      var out = "";
      for (i2 = fromStart + lastCommonSep + 1; i2 <= fromEnd; ++i2) {
        if (i2 === fromEnd || from.charCodeAt(i2) === 47) {
          if (out.length === 0)
            out += "..";
          else
            out += "/..";
        }
      }
      if (out.length > 0)
        return out + to.slice(toStart + lastCommonSep);
      else {
        toStart += lastCommonSep;
        if (to.charCodeAt(toStart) === 47)
          ++toStart;
        return to.slice(toStart);
      }
    },
    _makeLong: function _makeLong2(path) {
      return path;
    },
    dirname: function dirname2(path) {
      assertPath(path);
      if (path.length === 0)
        return ".";
      var code = path.charCodeAt(0);
      var hasRoot = code === 47;
      var end = -1;
      var matchedSlash = true;
      for (var i2 = path.length - 1; i2 >= 1; --i2) {
        code = path.charCodeAt(i2);
        if (code === 47) {
          if (!matchedSlash) {
            end = i2;
            break;
          }
        } else {
          matchedSlash = false;
        }
      }
      if (end === -1)
        return hasRoot ? "/" : ".";
      if (hasRoot && end === 1)
        return "//";
      return path.slice(0, end);
    },
    basename: function basename2(path, ext) {
      if (ext !== void 0 && typeof ext !== "string")
        throw new TypeError('"ext" argument must be a string');
      assertPath(path);
      var start = 0;
      var end = -1;
      var matchedSlash = true;
      var i2;
      if (ext !== void 0 && ext.length > 0 && ext.length <= path.length) {
        if (ext.length === path.length && ext === path)
          return "";
        var extIdx = ext.length - 1;
        var firstNonSlashEnd = -1;
        for (i2 = path.length - 1; i2 >= 0; --i2) {
          var code = path.charCodeAt(i2);
          if (code === 47) {
            if (!matchedSlash) {
              start = i2 + 1;
              break;
            }
          } else {
            if (firstNonSlashEnd === -1) {
              matchedSlash = false;
              firstNonSlashEnd = i2 + 1;
            }
            if (extIdx >= 0) {
              if (code === ext.charCodeAt(extIdx)) {
                if (--extIdx === -1) {
                  end = i2;
                }
              } else {
                extIdx = -1;
                end = firstNonSlashEnd;
              }
            }
          }
        }
        if (start === end)
          end = firstNonSlashEnd;
        else if (end === -1)
          end = path.length;
        return path.slice(start, end);
      } else {
        for (i2 = path.length - 1; i2 >= 0; --i2) {
          if (path.charCodeAt(i2) === 47) {
            if (!matchedSlash) {
              start = i2 + 1;
              break;
            }
          } else if (end === -1) {
            matchedSlash = false;
            end = i2 + 1;
          }
        }
        if (end === -1)
          return "";
        return path.slice(start, end);
      }
    },
    extname: function extname2(path) {
      assertPath(path);
      var startDot = -1;
      var startPart = 0;
      var end = -1;
      var matchedSlash = true;
      var preDotState = 0;
      for (var i2 = path.length - 1; i2 >= 0; --i2) {
        var code = path.charCodeAt(i2);
        if (code === 47) {
          if (!matchedSlash) {
            startPart = i2 + 1;
            break;
          }
          continue;
        }
        if (end === -1) {
          matchedSlash = false;
          end = i2 + 1;
        }
        if (code === 46) {
          if (startDot === -1)
            startDot = i2;
          else if (preDotState !== 1)
            preDotState = 1;
        } else if (startDot !== -1) {
          preDotState = -1;
        }
      }
      if (startDot === -1 || end === -1 || // We saw a non-dot character immediately before the dot
      preDotState === 0 || // The (right-most) trimmed path component is exactly '..'
      preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
        return "";
      }
      return path.slice(startDot, end);
    },
    format: function format2(pathObject) {
      if (pathObject === null || typeof pathObject !== "object") {
        throw new TypeError('The "pathObject" argument must be of type Object. Received type ' + typeof pathObject);
      }
      return _format("/", pathObject);
    },
    parse: function parse2(path) {
      assertPath(path);
      var ret = {
        root: "",
        dir: "",
        base: "",
        ext: "",
        name: ""
      };
      if (path.length === 0)
        return ret;
      var code = path.charCodeAt(0);
      var isAbsolute2 = code === 47;
      var start;
      if (isAbsolute2) {
        ret.root = "/";
        start = 1;
      } else {
        start = 0;
      }
      var startDot = -1;
      var startPart = 0;
      var end = -1;
      var matchedSlash = true;
      var i2 = path.length - 1;
      var preDotState = 0;
      for (; i2 >= start; --i2) {
        code = path.charCodeAt(i2);
        if (code === 47) {
          if (!matchedSlash) {
            startPart = i2 + 1;
            break;
          }
          continue;
        }
        if (end === -1) {
          matchedSlash = false;
          end = i2 + 1;
        }
        if (code === 46) {
          if (startDot === -1)
            startDot = i2;
          else if (preDotState !== 1)
            preDotState = 1;
        } else if (startDot !== -1) {
          preDotState = -1;
        }
      }
      if (startDot === -1 || end === -1 || // We saw a non-dot character immediately before the dot
      preDotState === 0 || // The (right-most) trimmed path component is exactly '..'
      preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
        if (end !== -1) {
          if (startPart === 0 && isAbsolute2)
            ret.base = ret.name = path.slice(1, end);
          else
            ret.base = ret.name = path.slice(startPart, end);
        }
      } else {
        if (startPart === 0 && isAbsolute2) {
          ret.name = path.slice(1, startDot);
          ret.base = path.slice(1, end);
        } else {
          ret.name = path.slice(startPart, startDot);
          ret.base = path.slice(startPart, end);
        }
        ret.ext = path.slice(startDot, end);
      }
      if (startPart > 0)
        ret.dir = path.slice(0, startPart - 1);
      else if (isAbsolute2)
        ret.dir = "/";
      return ret;
    },
    sep: "/",
    delimiter: ":",
    win32: null,
    posix: null
  };
  posix2.posix = posix2;
  exports$1 = posix2;
  return exports$1;
}
var exports2 = dew2();

// ../../node_modules/@jspm/core/nodelibs/browser/os.js
var exports$12 = {};
var _dewExec3 = false;
function dew3() {
  if (_dewExec3)
    return exports$12;
  _dewExec3 = true;
  exports$12.endianness = function() {
    return "LE";
  };
  exports$12.hostname = function() {
    if (typeof location !== "undefined") {
      return location.hostname;
    } else
      return "";
  };
  exports$12.loadavg = function() {
    return [];
  };
  exports$12.uptime = function() {
    return 0;
  };
  exports$12.freemem = function() {
    return Number.MAX_VALUE;
  };
  exports$12.totalmem = function() {
    return Number.MAX_VALUE;
  };
  exports$12.cpus = function() {
    return [];
  };
  exports$12.type = function() {
    return "Browser";
  };
  exports$12.release = function() {
    if (typeof navigator !== "undefined") {
      return navigator.appVersion;
    }
    return "";
  };
  exports$12.networkInterfaces = exports$12.getNetworkInterfaces = function() {
    return {};
  };
  exports$12.arch = function() {
    return "javascript";
  };
  exports$12.platform = function() {
    return "browser";
  };
  exports$12.tmpdir = exports$12.tmpDir = function() {
    return "/tmp";
  };
  exports$12.EOL = "\n";
  exports$12.homedir = function() {
    return "/";
  };
  return exports$12;
}
var exports3 = dew3();
var _endianness = new Uint8Array(new Uint16Array([1]).buffer)[0] === 1 ? "LE" : "BE";
exports3.endianness = function() {
  return _endianness;
};
exports3.homedir = function() {
  return "/home";
};
exports3.version = function() {
  return "";
};
exports3.arch = function() {
  return "x64";
};
exports3.totalmem = function() {
  return navigator.deviceMemory !== void 0 ? navigator.deviceMemory * (1 << 30) : 2 * (1 << 30);
};
exports3.cpus = function() {
  return Array(navigator.hardwareConcurrency || 0).fill({ model: "", times: {} });
};
exports3.uptime = uptime;
exports3.constants = {};
exports2.join(exports3.homedir(), ".tabby-client", "agent", "data.json");
var dataStore = void 0 ;
function splitLines(input) {
  const lines = input.match(/.*(?:$|\r?\n)/g)?.filter(Boolean) ?? [];
  if (lines.length > 0 && lines[lines.length - 1]?.endsWith("\n")) {
    lines.push("");
  }
  return lines;
}
function isBlank(input) {
  return input.trim().length === 0;
}
function getIndentationLevel(line, indentation) {
  if (indentation === void 0) {
    return line.match(/^[ \t]*/)?.[0]?.length ?? 0;
  } else if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else if (indentation.match(/^ *$/)) {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  } else {
    throw new Error(`Invalid indentation: ${indentation}`);
  }
}
function isBlockOpeningLine(lines, index) {
  if (index < 0 || index >= lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index]) < getIndentationLevel(lines[index + 1]);
}
function isBlockClosingLine(lines, index) {
  if (index <= 0 || index > lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index - 1]) > getIndentationLevel(lines[index]);
}
var autoClosingPairs = [
  {
    open: {
      chars: "(",
      reg: /\(/
    },
    close: {
      chars: ")",
      reg: /\)/
    }
  },
  {
    open: {
      chars: "[",
      reg: /\[/
    },
    close: {
      chars: "]",
      reg: /\]/
    }
  },
  {
    open: {
      chars: "{",
      reg: /\{/
    },
    close: {
      chars: "}",
      reg: /\}/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=\w)/
    },
    close: {
      chars: "/>",
      reg: /\/>/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=[/\w])/
    },
    close: {
      chars: ">",
      reg: />/
    }
  },
  {
    openOrClose: {
      chars: '"',
      reg: /"/
    }
  },
  {
    openOrClose: {
      chars: "'",
      reg: /'/
    }
  },
  {
    openOrClose: {
      chars: "`",
      reg: /`/
    }
  }
];
var regOnlyAutoClosingCloseChars = /^([)\]}>"'`]|(\/>))*$/g;
function findUnpairedAutoClosingChars(input) {
  const stack = [];
  let index = 0;
  while (index < input.length) {
    const remain = input.slice(index);
    let nextFound = {
      index: remain.length,
      found: void 0
    };
    autoClosingPairs.forEach((pair) => {
      Object.entries(pair).forEach(([pos, pattern]) => {
        const match = remain.match(pattern.reg);
        if (match && match.index !== void 0 && match.index < nextFound.index) {
          nextFound = {
            index: match.index,
            found: { pair, pos, pattern }
          };
        }
      });
    });
    if (!nextFound.found) {
      break;
    }
    switch (nextFound.found.pos) {
      case "openOrClose": {
        const chars = nextFound.found.pattern.chars;
        if (stack.length > 0 && stack.includes(chars)) {
          stack.splice(stack.lastIndexOf(chars), stack.length - stack.lastIndexOf(chars));
        } else {
          stack.push(chars);
        }
        break;
      }
      case "open": {
        stack.push(nextFound.found.pattern.chars);
        break;
      }
      case "close": {
        const pair = nextFound.found.pair;
        if (stack.length > 0 && "open" in pair && stack[stack.length - 1] === pair.open.chars) {
          stack.pop();
        } else {
          stack.push(nextFound.found.pattern.chars);
        }
        break;
      }
    }
    index += nextFound.index + nextFound.found.pattern.chars.length;
  }
  return stack;
}
function calcDistance(a2, b) {
  return levenshtein.get(a2, b);
}
function abortSignalFromAnyOf(signals) {
  const controller = new AbortController();
  for (const signal of signals) {
    if (signal?.aborted) {
      controller.abort(signal.reason);
      return signal;
    }
    signal?.addEventListener("abort", () => controller.abort(signal.reason), {
      signal: controller.signal
    });
  }
  return controller.signal;
}
var HttpError = class extends Error {
  constructor(response) {
    super(`${response.status} ${response.statusText}`);
    this.name = "HttpError";
    this.status = response.status;
    this.statusText = response.statusText;
    this.response = response;
  }
};
function isTimeoutError(error) {
  return error instanceof Error && error.name === "TimeoutError" || error instanceof HttpError && [408, 499].includes(error.status);
}
function isCanceledError(error) {
  return error instanceof Error && error.name === "AbortError";
}
function errorToString(error) {
  let message = error.message || error.toString();
  if (error.cause) {
    message += "\nCaused by: " + errorToString(error.cause);
  }
  return message;
}
var pinoOptions = { serializers: { error: pino.stdSerializers.err } };
var rootBasicLogger = pino(pinoOptions);
{
  rootBasicLogger.level = "silent";
}
var allBasicLoggers = [rootBasicLogger];
rootBasicLogger.onChild = (child) => {
  allBasicLoggers.push(child);
};
function toObjLogFn(logFn) {
  return (...args) => {
    const arg0 = args.shift();
    if (typeof arg0 === "string") {
      logFn(arg0, ...args);
    } else {
      const arg1 = args.shift();
      if (typeof arg1 === "string") {
        logFn(arg1, ...args, arg0);
      } else {
        logFn(arg0, arg1, ...args);
      }
    }
  };
}
function withComponent(logFn, component) {
  return (msg, ...args) => {
    logFn(`[${component}] ${msg ?? ""}`, ...args);
  };
}
var extraLogger = {
  loggers: [],
  child(component) {
    const buildLogFn = (level) => {
      const logFn = (...args) => {
        const arg0 = args.shift();
        this.loggers.forEach((logger4) => logger4[level](arg0, ...args));
      };
      return toObjLogFn(withComponent(logFn, component));
    };
    return {
      error: buildLogFn("error"),
      warn: buildLogFn("warn"),
      info: buildLogFn("info"),
      debug: buildLogFn("debug"),
      trace: buildLogFn("trace")
    };
  }
};
function logger(component) {
  const basic = rootBasicLogger.child({ component });
  const extra = extraLogger.child(component);
  const all = [basic, extra];
  const buildLogFn = (level) => {
    return (...args) => {
      const arg0 = args.shift();
      all.forEach((logger4) => logger4[level](arg0, ...args));
    };
  };
  return {
    error: buildLogFn("error"),
    warn: buildLogFn("warn"),
    info: buildLogFn("info"),
    debug: buildLogFn("debug"),
    trace: buildLogFn("trace")
  };
}

// src/Auth.ts
var RetryLimitReachedError = class extends Error {
  constructor(cause) {
    super();
    this.cause = cause;
    this.name = "RetryLimitReachedError";
  }
};
var _Auth = class _Auth extends EventEmitter {
  constructor(endpoint) {
    super();
    this.endpoint = endpoint;
    this.logger = logger("Auth");
    this.authApi = createClient({ baseUrl: "https://app.tabbyml.com/api" });
  }
  async init(options) {
    this.dataStore = options?.dataStore;
    if (this.dataStore instanceof EventEmitter) {
      this.dataStore.on("updated", async () => {
        const oldJwt = this.jwt;
        await this.load();
        if (!deepEqual4(oldJwt, this.jwt)) {
          super.emit("updated", this.jwt);
        }
      });
    }
    this.scheduleRefreshToken();
    await this.load();
  }
  get token() {
    return this.jwt?.token;
  }
  get user() {
    return this.jwt?.payload.email;
  }
  async load() {
    if (!this.dataStore) {
      return;
    }
    try {
      await this.dataStore.load();
      const storedJwt = this.dataStore.data.auth?.[this.endpoint]?.jwt;
      if (typeof storedJwt === "string" && this.jwt?.token !== storedJwt) {
        this.logger.debug({ storedJwt }, "Load jwt from data store.");
        const jwt = {
          token: storedJwt,
          payload: decodeJwt(storedJwt)
        };
        if (jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
          this.jwt = await this.refreshToken(jwt, _Auth.tokenStrategy.refresh.whenLoaded);
          await this.save();
        } else {
          this.jwt = jwt;
        }
      }
    } catch (error) {
      this.logger.debug({ error }, "Error when loading auth");
    }
  }
  async save() {
    if (!this.dataStore) {
      return;
    }
    try {
      if (this.jwt) {
        if (this.dataStore.data.auth?.[this.endpoint]?.jwt === this.jwt.token) {
          return;
        }
        this.dataStore.data.auth = { ...this.dataStore.data.auth, [this.endpoint]: { jwt: this.jwt.token } };
      } else {
        if (typeof this.dataStore.data.auth?.[this.endpoint] === "undefined") {
          return;
        }
        delete this.dataStore.data.auth[this.endpoint];
      }
      await this.dataStore.save();
      this.logger.debug("Save changes to data store.");
    } catch (error) {
      this.logger.error({ error }, "Error when saving auth");
    }
  }
  async reset() {
    if (this.jwt) {
      this.jwt = void 0;
      await this.save();
    }
  }
  async requestAuthUrl(options) {
    try {
      await this.reset();
      if (options?.signal.aborted) {
        throw options.signal.reason;
      }
      this.logger.debug("Start to request device token");
      const response = await this.authApi.POST("/device-token", {
        body: { auth_url: this.endpoint },
        signal: options?.signal
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const deviceToken = response.data;
      this.logger.debug({ deviceToken }, "Request device token response");
      const authUrl = new URL(_Auth.authPageUrl);
      authUrl.searchParams.append("code", deviceToken.data.code);
      return { authUrl: authUrl.toString(), code: deviceToken.data.code };
    } catch (error) {
      this.logger.error({ error }, "Error when requesting token");
      throw error;
    }
  }
  async pollingToken(code, options) {
    return new Promise((resolve2, reject) => {
      const signal = abortSignalFromAnyOf([AbortSignal.timeout(_Auth.tokenStrategy.polling.timeout), options?.signal]);
      const timer = setInterval(async () => {
        try {
          const response = await this.authApi.POST("/device-token/accept", { params: { query: { code } }, signal });
          if (response.error || !response.response.ok) {
            throw new HttpError(response.response);
          }
          const result = response.data;
          this.logger.debug({ result }, "Poll jwt response");
          this.jwt = {
            token: result.data.jwt,
            payload: decodeJwt(result.data.jwt)
          };
          super.emit("updated", this.jwt);
          await this.save();
          clearInterval(timer);
          resolve2(true);
        } catch (error) {
          if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
            this.logger.debug({ error }, "Expected error when polling jwt");
          } else {
            this.logger.error({ error }, "Error when polling jwt");
          }
        }
      }, _Auth.tokenStrategy.polling.interval);
      if (signal.aborted) {
        clearInterval(timer);
        reject(signal.reason);
      } else {
        signal.addEventListener("abort", () => {
          clearInterval(timer);
          reject(signal.reason);
        });
      }
    });
  }
  async refreshToken(jwt, options = { maxTry: 1, retryDelay: 1e3 }, retry = 0) {
    try {
      this.logger.debug({ retry }, "Start to refresh token");
      const response = await this.authApi.POST("/device-token/refresh", {
        headers: { Authorization: `Bearer ${jwt.token}` }
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const refreshedJwt = response.data;
      this.logger.debug({ refreshedJwt }, "Refresh token response");
      return {
        token: refreshedJwt.data.jwt,
        payload: decodeJwt(refreshedJwt.data.jwt)
      };
    } catch (error) {
      if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
        this.logger.debug({ error }, "Error when refreshing jwt");
      } else {
        this.logger.error({ error }, "Unknown error when refreshing jwt");
        if (retry < options.maxTry) {
          this.logger.debug(`Retry refreshing jwt after ${options.retryDelay}ms`);
          await new Promise((resolve2) => setTimeout(resolve2, options.retryDelay));
          return this.refreshToken(jwt, options, retry + 1);
        }
      }
      throw new RetryLimitReachedError(error);
    }
  }
  scheduleRefreshToken() {
    setInterval(async () => {
      if (!this.jwt) {
        return;
      }
      if (this.jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
        try {
          this.jwt = await this.refreshToken(this.jwt, _Auth.tokenStrategy.refresh.whenScheduled);
          super.emit("updated", this.jwt);
          await this.save();
        } catch (error) {
          this.logger.error({ error }, "Error when refreshing jwt");
        }
      } else {
        this.logger.debug("Check token, still valid");
      }
    }, _Auth.tokenStrategy.refresh.interval);
  }
};
_Auth.authPageUrl = "https://app.tabbyml.com/account/device-token";
_Auth.tokenStrategy = {
  polling: {
    // polling token after auth url generated
    interval: 5e3,
    // polling token every 5 seconds
    timeout: 5 * 60 * 1e3
    // stop polling after trying for 5 min
  },
  refresh: {
    // check token every 15 min, refresh token if it expires in 30 min
    interval: 15 * 60 * 1e3,
    beforeExpire: 30 * 60 * 1e3,
    whenLoaded: {
      // after token loaded from data store, refresh token if it is about to expire or has expired
      maxTry: 5,
      // keep loading time not too long
      retryDelay: 1e3
      // retry after 1 seconds
    },
    whenScheduled: {
      // if running until token is about to expire, refresh token as scheduled
      maxTry: 60,
      retryDelay: 30 * 1e3
      // retry after 30 seconds
    }
  }
};
var Auth = _Auth;

// src/AgentConfig.ts
var defaultAgentConfig = {
  server: {
    endpoint: "http://localhost:8080",
    token: "",
    requestHeaders: {},
    requestTimeout: 2 * 60 * 1e3
    // 2 minutes
  },
  completion: {
    prompt: {
      experimentalStripAutoClosingCharacters: false,
      maxPrefixLines: 20,
      maxSuffixLines: 20,
      clipboard: {
        minChars: 3,
        maxChars: 2e3
      }
    },
    debounce: {
      mode: "adaptive",
      interval: 250
      // ms
    }
  },
  postprocess: {
    limitScope: {
      experimentalSyntax: false,
      indentation: {
        experimentalKeepBlockScopeWhenCompletingLine: false
      }
    },
    calculateReplaceRange: {
      experimentalSyntax: false
    }
  },
  logs: {
    level: "silent"
  },
  tls: {
    caCerts: "system"
  },
  anonymousUsageTracking: {
    disable: false
  }
};
exports2.join(exports3.homedir(), ".tabby-client", "agent", "config.toml");
function isAtLineEndExcludingAutoClosedChar(suffix) {
  return suffix.trimEnd().match(regOnlyAutoClosingCloseChars);
}
var CompletionContext = class {
  constructor(request) {
    this.filepath = request.filepath;
    this.language = request.language;
    this.text = request.text;
    this.position = request.position;
    this.indentation = request.indentation;
    this.prefix = request.text.slice(0, request.position);
    this.suffix = request.text.slice(request.position);
    this.prefixLines = splitLines(this.prefix);
    this.suffixLines = splitLines(this.suffix);
    this.currentLinePrefix = this.prefixLines[this.prefixLines.length - 1] ?? "";
    this.currentLineSuffix = this.suffixLines[0] ?? "";
    this.clipboard = request.clipboard?.trim() ?? "";
    const lineEnd = isAtLineEndExcludingAutoClosedChar(this.suffixLines[0] ?? "");
    this.mode = lineEnd ? "default" : "fill-in-line";
    this.hash = hashObject({
      filepath: this.filepath,
      language: this.language,
      text: this.text,
      position: this.position,
      clipboard: this.clipboard
    });
  }
};

// src/CompletionCache.ts
var CompletionCache = class {
  constructor() {
    this.logger = logger("CompletionCache");
    this.options = {
      maxCount: 1e4,
      prebuildCache: {
        enabled: true,
        perCharacter: {
          lines: 1,
          max: 50
        },
        perLine: {
          max: 10
        },
        autoClosingPairCheck: {
          max: 3
        }
      }
    };
    this.cache = new LRUCache({
      max: this.options.maxCount
    });
  }
  has(key) {
    return this.cache.has(key.hash);
  }
  buildCache(key, value) {
    this.logger.debug({ key, value }, "Starting to build cache");
    const entries = this.createCacheEntries(key, value);
    entries.forEach((entry) => {
      this.cache.set(entry.key.hash, { value: entry.value, rebuildFlag: entry.rebuildFlag });
    });
    this.logger.debug({ newEntries: entries.length, cacheSize: this.cache.size }, "Cache updated");
  }
  get(key) {
    const entry = this.cache.get(key.hash);
    if (entry?.rebuildFlag) {
      this.buildCache(key, entry?.value);
    }
    return entry?.value;
  }
  createCacheEntries(key, value) {
    const list = [{ key, value, rebuildFlag: false }];
    if (this.options.prebuildCache.enabled) {
      for (const choice of value.choices) {
        const completionText = choice.text.slice(key.position - choice.replaceRange.start);
        const perLinePositions = this.getPerLinePositions(completionText);
        this.logger.trace({ completionText, perLinePositions }, "Calculate per-line cache positions");
        for (const position of perLinePositions) {
          const completionTextPrefix = completionText.slice(0, position);
          const completionTextPrefixWithAutoClosedChars = this.generateAutoClosedPrefixes(completionTextPrefix);
          for (const prefix of [completionTextPrefix, ...completionTextPrefixWithAutoClosedChars]) {
            const entry = {
              key: new CompletionContext({
                ...key,
                text: key.text.slice(0, key.position) + prefix + key.text.slice(key.position),
                position: key.position + position
              }),
              value: {
                ...value,
                choices: [
                  {
                    index: choice.index,
                    text: completionText.slice(position),
                    replaceRange: {
                      start: key.position + position,
                      end: key.position + position
                    }
                  }
                ]
              },
              rebuildFlag: true
            };
            this.logger.trace({ prefix, entry }, "Build per-line cache entry");
            list.push(entry);
          }
        }
        const perCharacterPositions = this.getPerCharacterPositions(completionText);
        this.logger.trace({ completionText, perCharacterPositions }, "Calculate per-character cache positions");
        for (const position of perCharacterPositions) {
          let lineStart = position;
          while (lineStart > 0 && completionText[lineStart - 1] !== "\n") {
            lineStart--;
          }
          const completionTextPrefix = completionText.slice(0, position);
          const completionTextPrefixWithAutoClosedChars = this.generateAutoClosedPrefixes(completionTextPrefix);
          for (const prefix of [completionTextPrefix, ...completionTextPrefixWithAutoClosedChars]) {
            const entry = {
              key: new CompletionContext({
                ...key,
                text: key.text.slice(0, key.position) + prefix + key.text.slice(key.position),
                position: key.position + position
              }),
              value: {
                ...value,
                choices: [
                  {
                    index: choice.index,
                    text: completionText.slice(lineStart),
                    replaceRange: {
                      start: key.position + lineStart,
                      end: key.position + position
                    }
                  }
                ]
              },
              rebuildFlag: false
            };
            this.logger.trace({ prefix, entry }, "Build per-character cache entry");
            list.push(entry);
          }
        }
      }
    }
    const result = list.reduce((prev, curr) => {
      const found = prev.find((entry) => entry.key.hash === curr.key.hash);
      if (found) {
        found.value.choices.push(...curr.value.choices);
        found.rebuildFlag = found.rebuildFlag || curr.rebuildFlag;
      } else {
        prev.push(curr);
      }
      return prev;
    }, []);
    return result;
  }
  // positions for every line end (before newline character) and line begin (after indent)
  getPerLinePositions(completion) {
    const result = [];
    const option = this.options.prebuildCache;
    const lines = splitLines(completion);
    let index = 0;
    let offset = 0;
    while (index < lines.length - 1 && index < option.perLine.max) {
      offset += lines[index]?.length ?? 0;
      result.push(offset - 1);
      result.push(offset);
      let offsetNextLineBegin = offset;
      while (offsetNextLineBegin < completion.length && completion[offsetNextLineBegin].match(/\s/)) {
        offsetNextLineBegin++;
      }
      result.push(offsetNextLineBegin);
      index++;
    }
    return result;
  }
  // positions for every character in the leading lines
  getPerCharacterPositions(completion) {
    const result = [];
    const option = this.options.prebuildCache;
    const text = splitLines(completion).slice(0, option.perCharacter.lines).join("");
    let offset = 0;
    while (offset < text.length && offset < option.perCharacter.max) {
      result.push(offset);
      offset++;
    }
    return result;
  }
  // FIXME: add unit tests
  // "function(" => ["function()"]
  // "call([" => ["call([]", "call([])" ]
  // "function(arg" => ["function(arg)" ]
  generateAutoClosedPrefixes(prefix) {
    const result = [];
    const unpaired = findUnpairedAutoClosingChars(prefix);
    let checkIndex = 0;
    let autoClosing = "";
    while (checkIndex < unpaired.length && checkIndex < this.options.prebuildCache.autoClosingPairCheck.max) {
      autoClosingPairs.filter((pair) => {
        let pattern;
        if ("open" in pair) {
          pattern = pair.open;
        } else {
          pattern = pair.openOrClose;
        }
        return pattern.chars === unpaired[unpaired.length - 1 - checkIndex];
      }).forEach((pair) => {
        let pattern;
        if ("close" in pair) {
          pattern = pair.close;
        } else {
          pattern = pair.openOrClose;
        }
        autoClosing += pattern.chars;
        result.push(prefix + autoClosing);
      });
      checkIndex++;
    }
    return result;
  }
};

// src/CompletionDebounce.ts
function clamp(min, max, value) {
  return Math.max(min, Math.min(max, value));
}
var CompletionDebounce = class {
  constructor() {
    this.lastCalledTimeStamp = 0;
    this.baseInterval = 200;
    // ms
    this.calledIntervalHistory = [];
    this.options = {
      baseIntervalSlideWindowAvg: {
        minSize: 20,
        maxSize: 100,
        min: 100,
        max: 400
      },
      adaptiveRate: {
        min: 1.5,
        max: 3
      },
      contextScoreWeights: {
        triggerCharacter: 0.5,
        noSuffixInCurrentLine: 0.4,
        noSuffix: 0.1
      },
      requestDelay: {
        min: 100,
        // ms
        max: 1e3
      }
    };
  }
  async debounce(context, options) {
    const { request, config: config2, responseTime } = context;
    if (request.manually) {
      return this.sleep(0, options);
    }
    if (config2.mode === "fixed") {
      return this.sleep(config2.interval, options);
    }
    const now = Date.now();
    this.updateBaseInterval(now - this.lastCalledTimeStamp);
    this.lastCalledTimeStamp = now;
    const contextScore = this.calcContextScore(request);
    const adaptiveRate = this.options.adaptiveRate.max - (this.options.adaptiveRate.max - this.options.adaptiveRate.min) * contextScore;
    const expectedLatency = adaptiveRate * this.baseInterval;
    const delay = clamp(this.options.requestDelay.min, this.options.requestDelay.max, expectedLatency - responseTime);
    return this.sleep(delay, options);
  }
  async sleep(delay, options) {
    return new Promise((resolve2, reject) => {
      const timer = setTimeout(resolve2, Math.min(delay, 2147483647));
      if (options?.signal) {
        if (options.signal.aborted) {
          clearTimeout(timer);
          reject(options.signal.reason);
        } else {
          options.signal.addEventListener("abort", () => {
            clearTimeout(timer);
            reject(options.signal.reason);
          });
        }
      }
    });
  }
  updateBaseInterval(interval) {
    if (interval > this.options.baseIntervalSlideWindowAvg.max) {
      return;
    }
    this.calledIntervalHistory.push(interval);
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.maxSize) {
      this.calledIntervalHistory.shift();
    }
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.minSize) {
      const avg = this.calledIntervalHistory.reduce((a2, b) => a2 + b, 0) / this.calledIntervalHistory.length;
      this.baseInterval = clamp(
        this.options.baseIntervalSlideWindowAvg.min,
        this.options.baseIntervalSlideWindowAvg.max,
        avg
      );
    }
  }
  // return score in [0, 1], 1 means the context has a high chance to accept the completion
  calcContextScore(request) {
    let score = 0;
    const weights = this.options.contextScoreWeights;
    const triggerCharacter = request.text[request.position - 1] ?? "";
    score += triggerCharacter.match(/^\W*$/) ? weights.triggerCharacter : 0;
    const suffix = request.text.slice(request.position) ?? "";
    const currentLineInSuffix = splitLines(suffix)[0] ?? "";
    score += currentLineInSuffix.match(/^\W*$/) ? weights.noSuffixInCurrentLine : 0;
    score += suffix.match(/^\W*$/) ? weights.noSuffix : 0;
    score = clamp(0, 1, score);
    return score;
  }
};

// src/ArrayExt.ts
if (!Array.prototype.distinct) {
  Array.prototype.distinct = function(identity) {
    return [...new Map(this.map((item) => [identity?.(item) ?? item, item])).values()];
  };
}
if (!Array.prototype.mapAsync) {
  Array.prototype.mapAsync = async function(callbackfn, thisArg) {
    return await Promise.all(this.map((item, index) => callbackfn.call(thisArg, item, index, this)));
  };
}

// src/postprocess/base.ts
var logger2 = logger("Postprocess");
function applyFilter(filter, context) {
  return applyChoiceFilter(async (choice) => {
    const replaceLength = context.position - choice.replaceRange.start;
    const input = choice.text.slice(replaceLength);
    const filtered = await filter(input, context);
    choice.text = choice.text.slice(0, replaceLength) + (filtered ?? "");
    return choice;
  }, context);
}
function applyChoiceFilter(choiceFilter, context) {
  return async (response) => {
    response.choices = (await response.choices.mapAsync(async (choice) => {
      return await choiceFilter(choice, context);
    })).filter((choice) => {
      return !!choice && !!choice.text;
    }).distinct((choice) => choice.text);
    return response;
  };
}

// src/postprocess/removeRepetitiveBlocks.ts
function blockSplitter(_) {
  return /\n(\s*)\n/g;
}
function removeRepetitiveBlocks() {
  return (input, context) => {
    const inputBlocks = input.split(blockSplitter());
    let repetitionCount = 0;
    const repetitionThreshold = 2;
    let index = inputBlocks.length - 2;
    while (index >= 1) {
      if (isBlank(inputBlocks[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputBlocks[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentBlock = inputBlocks[index].trim();
      const previousBlock = inputBlocks[prev].trim();
      const threshold = Math.max(0.1 * currentBlock.length, 0.1 * previousBlock.length);
      const distance = calcDistance(currentBlock, previousBlock);
      if (distance <= threshold) {
        repetitionCount++;
        index--;
      } else {
        break;
      }
    }
    if (repetitionCount >= repetitionThreshold) {
      logger2.debug(
        {
          inputBlocks,
          repetitionCount
        },
        "Remove repetitive blocks."
      );
      return inputBlocks.slice(0, index + 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/removeRepetitiveLines.ts
function removeRepetitiveLines() {
  return (input) => {
    const inputLines = splitLines(input);
    let repetitionCount = 0;
    const repetitionThreshold = 5;
    let index = inputLines.length - 2;
    while (index >= 1) {
      if (isBlank(inputLines[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputLines[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentLine = inputLines[index].trim();
      const previousLine = inputLines[prev].trim();
      const threshold = Math.max(0.1 * currentLine.length, 0.1 * previousLine.length);
      const distance = calcDistance(currentLine, previousLine);
      if (distance <= threshold) {
        repetitionCount++;
        index = prev;
      } else {
        break;
      }
    }
    if (repetitionCount >= repetitionThreshold) {
      logger2.debug(
        {
          inputLines,
          repetitionCount
        },
        "Remove repetitive lines."
      );
      return inputLines.slice(0, index + 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/removeLineEndsWithRepetition.ts
var repetitionTests = [
  /(.{3,}?)\1{5,}$/g,
  // match a 3+ characters pattern repeating 5+ times
  /(.{10,}?)\1{3,}$/g
  // match a 10+ characters pattern repeating 3+ times
];
function removeLineEndsWithRepetition() {
  return (input) => {
    const inputLines = splitLines(input);
    let index = inputLines.length - 1;
    while (index >= 0 && isBlank(inputLines[index])) {
      index--;
    }
    if (index < 0)
      return input;
    for (const test of repetitionTests) {
      const match = inputLines[index].match(test);
      if (match) {
        logger2.debug(
          {
            inputLines,
            lineNumber: index,
            match
          },
          "Remove line ends with repetition."
        );
        if (index < 1)
          return null;
        return inputLines.slice(0, index).join("").trimEnd();
      }
    }
    return input;
  };
}

// src/postprocess/removeDuplicatedBlockClosingLine.ts
function removeDuplicatedBlockClosingLine() {
  return (input, context) => {
    const { suffixLines, currentLinePrefix } = context;
    const inputLines = splitLines(input);
    if (inputLines.length < 2) {
      return input;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    if (!isBlockClosingLine(inputLinesForDetection, inputLines.length - 1)) {
      return input;
    }
    const inputEndingLine = inputLines[inputLines.length - 1];
    let suffixBeginningIndex = 1;
    while (suffixBeginningIndex < suffixLines.length && isBlank(suffixLines[suffixBeginningIndex])) {
      suffixBeginningIndex++;
    }
    if (suffixBeginningIndex >= suffixLines.length) {
      return input;
    }
    const suffixBeginningLine = suffixLines[suffixBeginningIndex];
    if (inputEndingLine.startsWith(suffixBeginningLine.trimEnd()) || suffixBeginningLine.startsWith(inputEndingLine.trimEnd())) {
      logger2.debug({ inputLines, suffixLines }, "Removing duplicated block closing line");
      return inputLines.slice(0, inputLines.length - 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/limitScopeByIndentation.ts
function parseIndentationContext(inputLines, inputLinesForDetection, context, config2) {
  const result = {
    indentLevelLimit: 0,
    allowClosingLine: true
  };
  const { prefixLines, suffixLines, currentLinePrefix } = context;
  if (inputLines.length == 0 || prefixLines.length == 0) {
    return result;
  }
  const isCurrentLineInPrefixBlank = isBlank(currentLinePrefix);
  let referenceLineInPrefixIndex = prefixLines.length - 1;
  while (referenceLineInPrefixIndex >= 0 && isBlank(prefixLines[referenceLineInPrefixIndex])) {
    referenceLineInPrefixIndex--;
  }
  if (referenceLineInPrefixIndex < 0) {
    return result;
  }
  const referenceLineInPrefix = prefixLines[referenceLineInPrefixIndex];
  const referenceLineInPrefixIndent = getIndentationLevel(referenceLineInPrefix);
  const currentLineInCompletion = inputLines[0];
  const isCurrentLineInCompletionBlank = isBlank(currentLineInCompletion);
  let referenceLineInCompletionIndex = 0;
  while (referenceLineInCompletionIndex < inputLines.length && isBlank(inputLines[referenceLineInCompletionIndex])) {
    referenceLineInCompletionIndex++;
  }
  if (referenceLineInCompletionIndex >= inputLines.length) {
    return result;
  }
  const referenceLineInCompletion = inputLines[referenceLineInCompletionIndex];
  let referenceLineInCompletionIndent;
  if (isCurrentLineInCompletionBlank) {
    referenceLineInCompletionIndent = getIndentationLevel(referenceLineInCompletion);
  } else {
    referenceLineInCompletionIndent = getIndentationLevel(currentLinePrefix + referenceLineInCompletion);
  }
  if (!isCurrentLineInCompletionBlank && !isCurrentLineInPrefixBlank) {
    if (config2.experimentalKeepBlockScopeWhenCompletingLine) {
      result.indentLevelLimit = referenceLineInPrefixIndent;
    } else {
      result.indentLevelLimit = referenceLineInPrefixIndent + 1;
      result.allowClosingLine && (result.allowClosingLine = isBlockOpeningLine(inputLinesForDetection, 0));
    }
  } else if (referenceLineInCompletionIndent > referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent + 1;
  } else if (referenceLineInCompletionIndent < referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  } else {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  }
  let firstNonBlankLineInSuffix = 1;
  while (firstNonBlankLineInSuffix < suffixLines.length && isBlank(suffixLines[firstNonBlankLineInSuffix])) {
    firstNonBlankLineInSuffix++;
  }
  if (firstNonBlankLineInSuffix < suffixLines.length) {
    const firstNonBlankLineInSuffixText = suffixLines[firstNonBlankLineInSuffix];
    result.allowClosingLine && (result.allowClosingLine = getIndentationLevel(firstNonBlankLineInSuffixText) < result.indentLevelLimit);
  }
  return result;
}
function limitScopeByIndentation(config2) {
  return (input, context) => {
    const { prefixLines, suffixLines, currentLinePrefix } = context;
    const inputLines = splitLines(input);
    const inputLinesForDetection = inputLines.map((line, index2) => {
      return index2 === 0 ? currentLinePrefix + line : line;
    });
    const indentContext = parseIndentationContext(inputLines, inputLinesForDetection, context, config2);
    let index = 1;
    while (index < inputLines.length) {
      const line = inputLines[index];
      const prevLine = inputLines[index - 1];
      if (isBlank(line)) {
        index++;
        continue;
      }
      const indentLevel = getIndentationLevel(line);
      if (indentLevel < indentContext.indentLevelLimit) {
        if (isBlockClosingLine(inputLinesForDetection, index) && isBlockOpeningLine(inputLinesForDetection, index)) {
          index++;
          continue;
        }
        if (indentContext.allowClosingLine && (context.language !== "python" || !isBlank(prevLine))) {
          index++;
        }
        break;
      }
      index++;
    }
    if (index < inputLines.length) {
      logger2.debug(
        { inputLines, prefixLines, suffixLines, scopeLineCount: index },
        "Remove content out of indent scope"
      );
      return inputLines.slice(0, index).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/limitScope.ts
function limitScope(config2) {
  return async (input, context) => {
    return limitScopeByIndentation(config2["indentation"])(input, context);
  };
}

// src/postprocess/formatIndentation.ts
function detectIndentation(lines) {
  const matches = {
    "	": 0,
    "  ": 0,
    "    ": 0
  };
  for (const line of lines) {
    if (line.match(/^\t/)) {
      matches["	"]++;
    } else {
      const spaces = line.match(/^ */)?.[0].length ?? 0;
      if (spaces > 0) {
        if (spaces % 4 === 0) {
          matches["    "]++;
        }
        if (spaces % 2 === 0) {
          matches["  "]++;
        }
      }
    }
  }
  if (matches["	"] > 0) {
    return "	";
  }
  if (matches["  "] > matches["    "]) {
    return "  ";
  }
  if (matches["    "] > 0) {
    return "    ";
  }
  return null;
}
function getIndentLevel(line, indentation) {
  if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  }
}
function formatIndentation() {
  return (input, context) => {
    const { prefixLines, suffixLines, currentLinePrefix, indentation } = context;
    const inputLines = splitLines(input);
    if (!indentation) {
      return input;
    }
    const prefixLinesForDetection = isBlank(currentLinePrefix) ? prefixLines.slice(0, prefixLines.length - 1) : prefixLines;
    if (prefixLines.length > 1 && detectIndentation(prefixLinesForDetection) !== null) {
      return input;
    }
    const suffixLinesForDetection = suffixLines.slice(1);
    if (suffixLines.length > 1 && detectIndentation(suffixLinesForDetection) !== null) {
      return input;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    const inputIndentation = detectIndentation(inputLinesForDetection);
    if (inputIndentation === null || inputIndentation === indentation) {
      return input;
    }
    const formatted = inputLinesForDetection.map((line, index) => {
      const level = getIndentLevel(line, inputIndentation);
      if (level === 0) {
        return inputLines[index];
      }
      const rest = line.slice(inputIndentation.length * level);
      if (index === 0) {
        if (!isBlank(currentLinePrefix)) {
          return inputLines[0];
        } else {
          return indentation.repeat(level).slice(currentLinePrefix.length) + rest;
        }
      } else {
        return indentation.repeat(level) + rest;
      }
    });
    logger2.debug({ prefixLines, suffixLines, inputLines, formatted }, "Format indentation.");
    return formatted.join("");
  };
}

// src/postprocess/trimSpace.ts
function trimSpace() {
  return (input, context) => {
    const { currentLinePrefix, currentLineSuffix } = context;
    let trimmedInput = input;
    if (!isBlank(currentLinePrefix) && currentLinePrefix.match(/\s$/)) {
      trimmedInput = trimmedInput.trimStart();
    }
    if (isBlank(currentLineSuffix) || !isBlank(currentLineSuffix) && currentLineSuffix.match(/^\s/)) {
      trimmedInput = trimmedInput.trimEnd();
    }
    return trimmedInput;
  };
}

// src/postprocess/trimMultiLineInSingleLineMode.ts
function trimMultiLineInSingleLineMode() {
  return (input, context) => {
    const inputLines = splitLines(input);
    if (context.mode === "fill-in-line" && inputLines.length > 1) {
      const suffix = context.currentLineSuffix.trimEnd();
      const inputLine = inputLines[0].trimEnd();
      if (inputLine.endsWith(suffix)) {
        const trimmedInputLine = inputLine.slice(0, -suffix.length);
        if (trimmedInputLine.length > 0) {
          logger2.debug({ inputLines, trimmedInputLine }, "Trim content with multiple lines");
          return trimmedInputLine;
        }
      }
      logger2.debug({ inputLines }, "Drop content with multiple lines");
      return null;
    }
    return input;
  };
}

// src/postprocess/dropDuplicated.ts
function dropDuplicated() {
  return (input, context) => {
    const { suffixLines } = context;
    const inputLines = splitLines(input);
    let inputIndex = 0;
    while (inputIndex < inputLines.length && isBlank(inputLines[inputIndex])) {
      inputIndex++;
    }
    let suffixIndex = 0;
    while (suffixIndex < suffixLines.length && isBlank(suffixLines[suffixIndex])) {
      suffixIndex++;
    }
    const lineCount = Math.min(3, inputLines.length - inputIndex, suffixLines.length - suffixIndex);
    if (lineCount < 1)
      return input;
    const inputToCompare = inputLines.slice(inputIndex, inputIndex + lineCount).join("").trim();
    const suffixToCompare = suffixLines.slice(suffixIndex, suffixIndex + lineCount).join("").trim();
    const threshold = Math.max(1, 0.05 * inputToCompare.length, 0.05 * suffixToCompare.length);
    const distance = calcDistance(inputToCompare, suffixToCompare);
    if (distance <= threshold) {
      logger2.debug(
        { inputLines, suffixLines, inputToCompare, suffixToCompare, distance, threshold },
        "Drop completion due to duplicated."
      );
      return null;
    }
    return input;
  };
}

// src/postprocess/dropBlank.ts
function dropBlank() {
  return (input) => {
    return isBlank(input) ? null : input;
  };
}

// src/postprocess/calculateReplaceRangeByBracketStack.ts
function calculateReplaceRangeByBracketStack(choice, context) {
  const { currentLineSuffix } = context;
  const suffixText = currentLineSuffix.trimEnd();
  if (isBlank(suffixText)) {
    return choice;
  }
  const completionText = choice.text.slice(context.position - choice.replaceRange.start);
  const unpaired = findUnpairedAutoClosingChars(completionText).join("");
  if (isBlank(unpaired)) {
    return choice;
  }
  if (suffixText.startsWith(unpaired)) {
    choice.replaceRange.end = context.position + unpaired.length;
    logger2.trace(
      { context, completion: choice.text, range: choice.replaceRange, unpaired },
      "Adjust replace range by bracket stack"
    );
  } else if (unpaired.startsWith(suffixText)) {
    choice.replaceRange.end = context.position + suffixText.length;
    logger2.trace(
      { context, completion: choice.text, range: choice.replaceRange, unpaired },
      "Adjust replace range by bracket stack"
    );
  }
  return choice;
}

// src/postprocess/calculateReplaceRange.ts
function calculateReplaceRange(config2) {
  return async (choice, context) => {
    return calculateReplaceRangeByBracketStack(choice, context);
  };
}

// src/postprocess/index.ts
async function preCacheProcess(context, _, response) {
  return Promise.resolve(response).then(applyFilter(trimMultiLineInSingleLineMode(), context)).then(applyFilter(removeLineEndsWithRepetition(), context)).then(applyFilter(dropDuplicated(), context)).then(applyFilter(trimSpace(), context)).then(applyFilter(dropBlank(), context));
}
async function postCacheProcess(context, config2, response) {
  return Promise.resolve(response).then(applyFilter(removeRepetitiveBlocks(), context)).then(applyFilter(removeRepetitiveLines(), context)).then(applyFilter(limitScope(config2["limitScope"]), context)).then(applyFilter(removeDuplicatedBlockClosingLine(), context)).then(applyFilter(formatIndentation(), context)).then(applyFilter(dropDuplicated(), context)).then(applyFilter(trimSpace(), context)).then(applyFilter(dropBlank(), context)).then(applyChoiceFilter(calculateReplaceRange(), context));
}

// package.json
var name2 = "tabby-agent";
var version3 = "1.4.2";

// src/AnonymousUsageLogger.ts
var AnonymousUsageLogger = class {
  constructor() {
    this.anonymousUsageTrackingApi = createClient({ baseUrl: "https://app.tabbyml.com/api" });
    this.logger = logger("AnonymousUsage");
    this.systemData = {
      agent: `${name2}, ${version3}`,
      browser: navigator?.userAgent || "browser" ,
      node: void 0 
    };
    this.sessionProperties = {};
    this.userProperties = {};
    this.userPropertiesUpdated = false;
    this.emittedUniqueEvent = [];
    this.disabled = false;
  }
  async init(options) {
    this.dataStore = options?.dataStore;
    if (this.dataStore) {
      if (typeof this.dataStore.data["anonymousId"] === "string") {
        this.anonymousId = this.dataStore.data["anonymousId"];
      } else {
        this.anonymousId = v4();
        this.dataStore.data["anonymousId"] = this.anonymousId;
        try {
          await this.dataStore.save();
        } catch (error) {
          this.logger.debug({ error }, "Error when saving anonymousId");
        }
      }
    } else {
      this.anonymousId = v4();
    }
  }
  /**
   * Set properties to be sent with every event in this session.
   */
  setSessionProperties(key, value) {
    setProperty(this.sessionProperties, key, value);
  }
  /**
   * Set properties which will be bind to the user.
   */
  setUserProperties(key, value) {
    setProperty(this.userProperties, key, value);
    this.userPropertiesUpdated = true;
  }
  async uniqueEvent(event, data = {}) {
    await this.event(event, data, true);
  }
  async event(event, data = {}, unique = false) {
    if (this.disabled || !this.anonymousId) {
      return;
    }
    if (unique && this.emittedUniqueEvent.includes(event)) {
      return;
    }
    if (unique) {
      this.emittedUniqueEvent.push(event);
    }
    const properties = {
      ...this.systemData,
      ...this.sessionProperties,
      ...data
    };
    if (this.userPropertiesUpdated) {
      setProperty(properties, "$set", this.userProperties);
      this.userPropertiesUpdated = false;
    }
    try {
      await this.anonymousUsageTrackingApi.POST("/usage", {
        body: {
          distinctId: this.anonymousId,
          event,
          properties
        }
      });
    } catch (error) {
      this.logger.error({ error }, "Error when sending anonymous usage data");
    }
  }
};
var Average = class {
  constructor() {
    this.sum = 0;
    this.quantity = 0;
  }
  add(value) {
    this.sum += value;
    this.quantity += 1;
  }
  mean() {
    if (this.quantity === 0) {
      return void 0;
    }
    return this.sum / this.quantity;
  }
  count() {
    return this.quantity;
  }
};
var Windowed = class {
  constructor(maxSize) {
    this.values = [];
    this.maxSize = maxSize;
  }
  add(value) {
    this.values.push(value);
    if (this.values.length > this.maxSize) {
      this.values.shift();
    }
  }
  getValues() {
    return this.values;
  }
};
var CompletionProviderStats = class {
  constructor() {
    this.config = {
      windowSize: 10,
      checks: {
        disable: false,
        // Mark status as healthy if the latency is less than the threshold for each latest windowSize requests.
        healthy: { windowSize: 1, latency: 3e3 },
        // If there is at least {count} requests, and the average response time is higher than the {latency}, show warning
        slowResponseTime: { latency: 5e3, count: 1 },
        // If there is at least {count} timeouts, and the timeout rate is higher than the {rate}, show warning
        highTimeoutRate: { rate: 0.5, count: 1 }
      }
    };
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.cacheHitCount = 0;
    this.cacheMissCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new Univariate();
    this.completionRequestCanceledStats = new Average();
    this.completionRequestTimeoutCount = 0;
    this.recentCompletionRequestLatencies = new Windowed(this.config.windowSize);
  }
  add(value) {
    const { triggerMode, cacheHit, aborted, requestSent, requestLatency, requestCanceled, requestTimeout } = value;
    if (!aborted) {
      if (triggerMode === "auto") {
        this.autoCompletionCount += 1;
      } else {
        this.manualCompletionCount += 1;
      }
      if (cacheHit) {
        this.cacheHitCount += 1;
      } else {
        this.cacheMissCount += 1;
      }
    }
    if (requestSent) {
      if (requestCanceled) {
        this.completionRequestCanceledStats.add(requestLatency);
      } else if (requestTimeout) {
        this.completionRequestTimeoutCount += 1;
      } else {
        this.completionRequestLatencyStats.add(requestLatency);
      }
      if (!requestCanceled) {
        this.recentCompletionRequestLatencies.add(requestLatency);
      }
    }
  }
  addEvent(event) {
    const count = this.eventMap.get(event) || 0;
    this.eventMap.set(event, count + 1);
  }
  reset() {
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.cacheHitCount = 0;
    this.cacheMissCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new Univariate();
    this.completionRequestCanceledStats = new Average();
    this.completionRequestTimeoutCount = 0;
  }
  resetWindowed() {
    this.recentCompletionRequestLatencies = new Windowed(this.config.windowSize);
  }
  // stats for anonymous usage report
  stats() {
    const eventCount = Object.fromEntries(
      Array.from(this.eventMap.entries()).map(([key, value]) => ["count_" + key, value])
    );
    return {
      completion: {
        count_auto: this.autoCompletionCount,
        count_manual: this.manualCompletionCount,
        cache_hit: this.cacheHitCount,
        cache_miss: this.cacheMissCount,
        ...eventCount
      },
      completion_request: {
        count: this.completionRequestLatencyStats.count(),
        latency_avg: this.completionRequestLatencyStats.mean(),
        latency_p50: this.completionRequestLatencyStats.percentile(50),
        latency_p95: this.completionRequestLatencyStats.percentile(95),
        latency_p99: this.completionRequestLatencyStats.percentile(99)
      },
      completion_request_canceled: {
        count: this.completionRequestCanceledStats.count(),
        latency_avg: this.completionRequestCanceledStats.mean()
      },
      completion_request_timeout: {
        count: this.completionRequestTimeoutCount
      }
    };
  }
  // stats for "highTimeoutRate" | "slowResponseTime" warning
  windowed() {
    const latencies = this.recentCompletionRequestLatencies.getValues();
    const timeouts = latencies.filter((latency) => Number.isNaN(latency));
    const responses = latencies.filter((latency) => !Number.isNaN(latency));
    const averageResponseTime = responses.reduce((acc, latency) => acc + latency, 0) / responses.length;
    return {
      values: latencies,
      stats: {
        total: latencies.length,
        timeouts: timeouts.length,
        responses: responses.length,
        averageResponseTime
      }
    };
  }
  check(windowed) {
    if (this.config.checks.disable) {
      return null;
    }
    const config2 = this.config.checks;
    const {
      values: latencies,
      stats: { total, timeouts, responses, averageResponseTime }
    } = windowed;
    if (latencies.slice(-Math.min(this.config.windowSize, config2.healthy.windowSize)).every((latency) => latency < config2.healthy.latency)) {
      return "healthy";
    }
    if (timeouts / total > config2.highTimeoutRate.rate && timeouts >= config2.highTimeoutRate.count) {
      return "highTimeoutRate";
    }
    if (averageResponseTime > config2.slowResponseTime.latency && responses >= config2.slowResponseTime.count) {
      return "slowResponseTime";
    }
    return null;
  }
};
logger("CaCert");
async function loadTlsCaCerts(options) {
  {
    return;
  }
}

// src/TabbyAgent.ts
var _TabbyAgent = class _TabbyAgent extends EventEmitter {
  constructor() {
    super();
    this.logger = logger("TabbyAgent");
    this.anonymousUsageLogger = new AnonymousUsageLogger();
    this.config = defaultAgentConfig;
    this.userConfig = {};
    // config from `~/.tabby-client/agent/config.toml`
    this.clientConfig = {};
    // config from `initialize` and `updateConfig` method
    this.serverProvidedConfig = {};
    // config fetched from server and saved in dataStore
    this.status = "notInitialized";
    this.issues = [];
    this.completionCache = new CompletionCache();
    this.completionDebounce = new CompletionDebounce();
    this.completionProviderStats = new CompletionProviderStats();
    this.tryingConnectTimer = setInterval(async () => {
      if (this.status === "disconnected") {
        this.logger.debug("Trying to connect...");
        await this.healthCheck();
      }
    }, _TabbyAgent.tryConnectInterval);
    this.submitStatsTimer = setInterval(async () => {
      await this.submitStats();
    }, _TabbyAgent.submitStatsInterval);
  }
  async applyConfig() {
    const oldConfig = this.config;
    const oldStatus = this.status;
    this.config = deepmerge(
      defaultAgentConfig,
      this.userConfig,
      this.clientConfig,
      this.serverProvidedConfig
    );
    allBasicLoggers.forEach((logger4) => logger4.level = this.config.logs.level);
    this.anonymousUsageLogger.disabled = this.config.anonymousUsageTracking.disable;
    await loadTlsCaCerts();
    if (isBlank(this.config.server.token) && this.config.server.requestHeaders["Authorization"] === void 0) {
      if (this.config.server.endpoint !== this.auth?.endpoint) {
        this.auth = new Auth(this.config.server.endpoint);
        await this.auth.init({ dataStore: this.dataStore });
        this.auth.on("updated", () => {
          this.setupApi();
        });
      }
    } else {
      this.auth = void 0;
    }
    if (!deepEqual4(oldConfig.server, this.config.server)) {
      this.serverHealthState = void 0;
      this.completionProviderStats.resetWindowed();
      this.popIssue("slowCompletionResponseTime");
      this.popIssue("highCompletionTimeoutRate");
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
    }
    if (!this.api || !deepEqual4(oldConfig.server, this.config.server)) {
      await this.setupApi();
      this.fetchServerConfig();
    }
    if (!deepEqual4(oldConfig.server, this.config.server)) {
      if (oldStatus === "unauthorized" && this.status === "unauthorized") {
        this.emitAuthRequired();
      }
    }
    const event = { event: "configUpdated", config: this.config };
    this.logger.debug({ event }, "Config updated");
    super.emit("configUpdated", event);
  }
  async setupApi() {
    const auth = !isBlank(this.config.server.token) ? `Bearer ${this.config.server.token}` : this.auth?.token ? `Bearer ${this.auth.token}` : void 0;
    this.api = createClient({
      baseUrl: this.config.server.endpoint.replace(/\/+$/, ""),
      // remove trailing slash
      headers: {
        Authorization: auth,
        ...this.config.server.requestHeaders
      }
    });
    await this.healthCheck();
  }
  changeStatus(status) {
    if (this.status != status) {
      this.status = status;
      const event = { event: "statusChanged", status };
      this.logger.debug({ event }, "Status changed");
      super.emit("statusChanged", event);
      if (this.status === "unauthorized") {
        this.emitAuthRequired();
      }
    }
  }
  issueFromName(issueName) {
    switch (issueName) {
      case "highCompletionTimeoutRate":
        return {
          name: "highCompletionTimeoutRate",
          completionResponseStats: this.completionProviderStats.windowed().stats
        };
      case "slowCompletionResponseTime":
        return {
          name: "slowCompletionResponseTime",
          completionResponseStats: this.completionProviderStats.windowed().stats
        };
      case "connectionFailed":
        return {
          name: "connectionFailed",
          message: this.connectionErrorMessage
        };
    }
  }
  pushIssue(issue) {
    if (!this.issues.includes(issue)) {
      this.issues.push(issue);
      this.logger.debug({ issue }, "Issues Pushed");
      this.emitIssueUpdated();
    }
  }
  popIssue(issue) {
    const index = this.issues.indexOf(issue);
    if (index >= 0) {
      this.issues.splice(index, 1);
      this.logger.debug({ issue }, "Issues Popped");
      this.emitIssueUpdated();
    }
  }
  emitAuthRequired() {
    const event = { event: "authRequired", server: this.config.server };
    super.emit("authRequired", event);
  }
  emitIssueUpdated() {
    const event = { event: "issuesUpdated", issues: this.issues };
    super.emit("issuesUpdated", event);
  }
  async submitStats() {
    const stats = this.completionProviderStats.stats();
    if (stats.completion_request.count > 0) {
      await this.anonymousUsageLogger.event("AgentStats", { stats });
      this.completionProviderStats.reset();
      this.logger.debug({ stats }, "Stats submitted");
    }
  }
  createAbortSignal(options) {
    const timeout = Math.min(2147483647, options?.timeout || this.config.server.requestTimeout);
    return abortSignalFromAnyOf([AbortSignal.timeout(timeout), options?.signal]);
  }
  async healthCheck(options) {
    const requestId = v4();
    const requestPath = "/v1/health";
    const requestUrl = this.config.server.endpoint + requestPath;
    const requestOptions = {
      signal: this.createAbortSignal({ signal: options?.signal })
    };
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      this.logger.debug({ requestId, requestOptions, url: requestUrl }, "Health check request");
      let response;
      if (options?.method === "POST") {
        response = await this.api.POST(requestPath, requestOptions);
      } else {
        response = await this.api.GET(requestPath, requestOptions);
      }
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.debug({ requestId, response }, "Health check response");
      this.changeStatus("ready");
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
      const healthState = response.data;
      if (typeof healthState === "object" && healthState["model"] !== void 0 && healthState["device"] !== void 0) {
        this.serverHealthState = healthState;
        this.anonymousUsageLogger.uniqueEvent("AgentConnected", healthState);
        this.fetchServerConfig();
      }
    } catch (error) {
      this.serverHealthState = void 0;
      if (error instanceof HttpError && error.status == 405 && options?.method !== "POST") {
        return await this.healthCheck({ method: "POST" });
      } else if (error instanceof HttpError && [401, 403].includes(error.status)) {
        this.logger.debug({ requestId, error }, "Health check error: unauthorized");
        this.changeStatus("unauthorized");
      } else {
        if (isTimeoutError(error)) {
          this.logger.debug({ requestId, error }, "Health check error: timeout");
          this.connectionErrorMessage = `GET ${requestUrl}: Timed out.`;
        } else if (isCanceledError(error)) {
          this.logger.debug({ requestId, error }, "Health check error: canceled");
          this.connectionErrorMessage = `GET ${requestUrl}: Canceled.`;
        } else {
          this.logger.error({ requestId, error }, "Health check error: unknown error");
          const message = error instanceof Error ? errorToString(error) : JSON.stringify(error);
          this.connectionErrorMessage = `GET ${requestUrl}: Request failed: 
${message}`;
        }
        this.pushIssue("connectionFailed");
        this.changeStatus("disconnected");
      }
    }
  }
  async fetchServerConfig() {
    const requestId = v4();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1beta/server_setting";
      this.logger.debug({ requestId, url: this.config.server.endpoint + requestPath }, "Fetch server config request");
      const response = await this.api.GET(requestPath);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.debug({ requestId, response }, "Fetch server config response");
      const fetchedConfig = response.data;
      const serverProvidedConfig = {};
      if (fetchedConfig.disable_client_side_telemetry) {
        serverProvidedConfig.anonymousUsageTracking = {
          disable: true
        };
      }
      if (!deepEqual4(serverProvidedConfig, this.serverProvidedConfig)) {
        this.serverProvidedConfig = serverProvidedConfig;
        await this.applyConfig();
        if (this.dataStore) {
          if (!this.dataStore.data.serverConfig) {
            this.dataStore.data.serverConfig = {};
          }
          this.dataStore.data.serverConfig[this.config.server.endpoint] = this.serverProvidedConfig;
          try {
            await this.dataStore.save();
          } catch (error) {
            this.logger.error({ error }, "Error when saving serverConfig");
          }
        }
      }
    } catch (error) {
      this.logger.error({ requestId, error }, "Fetch server config error");
    }
  }
  createSegments(context) {
    const maxPrefixLines = this.config.completion.prompt.maxPrefixLines;
    const maxSuffixLines = this.config.completion.prompt.maxSuffixLines;
    const { prefixLines, suffixLines } = context;
    const prefix = prefixLines.slice(Math.max(prefixLines.length - maxPrefixLines, 0)).join("");
    let suffix;
    if (this.config.completion.prompt.experimentalStripAutoClosingCharacters && context.mode !== "fill-in-line") {
      suffix = "\n" + suffixLines.slice(1, maxSuffixLines).join("");
    } else {
      suffix = suffixLines.slice(0, maxSuffixLines).join("");
    }
    let clipboard = void 0;
    const clipboardConfig = this.config.completion.prompt.clipboard;
    if (context.clipboard.length >= clipboardConfig.minChars && context.clipboard.length <= clipboardConfig.maxChars) {
      clipboard = context.clipboard;
    }
    return { prefix, suffix, clipboard };
  }
  async initialize(options) {
    if (options.loggers) {
      extraLogger.loggers = options.loggers;
    }
    this.dataStore = options.dataStore ?? dataStore;
    if (this.dataStore) {
      try {
        await this.dataStore.load();
        if ("watch" in this.dataStore && typeof this.dataStore.watch === "function") {
          this.dataStore.watch();
        }
      } catch (error) {
        this.logger.debug({ error }, "No stored data loaded.");
      }
    }
    await this.anonymousUsageLogger.init({ dataStore: this.dataStore });
    if (options.clientProperties) {
      const { user: userProp, session: sessionProp } = options.clientProperties;
      allBasicLoggers.forEach((logger4) => logger4.setBindings?.({ ...sessionProp }));
      if (sessionProp) {
        Object.entries(sessionProp).forEach(([key, value]) => {
          this.anonymousUsageLogger.setSessionProperties(key, value);
        });
      }
      if (userProp) {
        Object.entries(userProp).forEach(([key, value]) => {
          this.anonymousUsageLogger.setUserProperties(key, value);
        });
      }
    }
    if (options.config) {
      this.clientConfig = options.config;
    }
    if (this.dataStore) {
      const localConfig = deepmerge(defaultAgentConfig, this.userConfig, this.clientConfig);
      this.serverProvidedConfig = this.dataStore?.data.serverConfig?.[localConfig.server.endpoint] ?? {};
      if (this.dataStore instanceof EventEmitter) {
        this.dataStore.on("updated", async () => {
          const localConfig2 = deepmerge(defaultAgentConfig, this.userConfig, this.clientConfig);
          const storedServerConfig = dataStore?.data.serverConfig?.[localConfig2.server.endpoint];
          if (!deepEqual4(storedServerConfig, this.serverProvidedConfig)) {
            this.serverProvidedConfig = {};
            await this.applyConfig();
          }
        });
      }
    }
    await this.applyConfig();
    await this.anonymousUsageLogger.uniqueEvent("AgentInitialized");
    this.logger.debug({ options }, "Initialized");
    return this.status !== "notInitialized";
  }
  async finalize() {
    if (this.status === "finalized") {
      return false;
    }
    await this.submitStats();
    if (this.tryingConnectTimer) {
      clearInterval(this.tryingConnectTimer);
    }
    if (this.submitStatsTimer) {
      clearInterval(this.submitStatsTimer);
    }
    this.changeStatus("finalized");
    return true;
  }
  async updateClientProperties(type2, key, value) {
    switch (type2) {
      case "session":
        allBasicLoggers.forEach((logger4) => logger4.setBindings?.(setProperty({}, key, value)));
        this.anonymousUsageLogger.setSessionProperties(key, value);
        break;
      case "user":
        this.anonymousUsageLogger.setUserProperties(key, value);
        break;
    }
    return true;
  }
  async updateConfig(key, value) {
    const current = getProperty(this.clientConfig, key);
    if (!deepEqual4(current, value)) {
      if (value === void 0) {
        deleteProperty(this.clientConfig, key);
      } else {
        setProperty(this.clientConfig, key, value);
      }
      await this.applyConfig();
    }
    return true;
  }
  async clearConfig(key) {
    return await this.updateConfig(key, void 0);
  }
  getConfig() {
    return this.config;
  }
  getStatus() {
    return this.status;
  }
  getIssues() {
    return this.issues;
  }
  getIssueDetail(options) {
    const issues = this.getIssues();
    if (options.index !== void 0 && options.index < issues.length) {
      return this.issueFromName(issues[options.index]);
    } else if (options.name !== void 0 && this.issues.includes(options.name)) {
      return this.issueFromName(options.name);
    } else {
      return null;
    }
  }
  getServerHealthState() {
    return this.serverHealthState ?? null;
  }
  async requestAuthUrl(options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    await this.healthCheck(options);
    if (this.status !== "unauthorized" || !this.auth) {
      return null;
    } else {
      return await this.auth.requestAuthUrl(options);
    }
  }
  async waitForAuthToken(code, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    if (this.status !== "unauthorized" || !this.auth) {
      return;
    }
    await this.auth.pollingToken(code, options);
    await this.setupApi();
  }
  async provideCompletions(request, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.logger.trace({ request }, "Call provideCompletions");
    if (this.nonParallelProvideCompletionAbortController) {
      this.nonParallelProvideCompletionAbortController.abort();
    }
    this.nonParallelProvideCompletionAbortController = new AbortController();
    const signal = abortSignalFromAnyOf([this.nonParallelProvideCompletionAbortController.signal, options?.signal]);
    let completionResponse;
    let stats = {
      triggerMode: request.manually ? "manual" : "auto",
      cacheHit: false,
      aborted: false,
      requestSent: false,
      requestLatency: 0,
      requestCanceled: false,
      requestTimeout: false
    };
    let requestStartedAt;
    const context = new CompletionContext(request);
    try {
      if (this.completionCache.has(context)) {
        stats.cacheHit = true;
        this.logger.debug({ context }, "Completion cache hit");
        await this.completionDebounce.debounce(
          {
            request,
            config: this.config.completion.debounce,
            responseTime: 0
          },
          { signal }
        );
        completionResponse = this.completionCache.get(context);
      } else {
        stats.cacheHit = false;
        const segments = this.createSegments(context);
        if (isBlank(segments.prefix)) {
          stats = void 0;
          this.logger.debug("Segment prefix is blank, returning empty completion response");
          completionResponse = {
            id: "agent-" + v4(),
            choices: []
          };
        } else {
          await this.completionDebounce.debounce(
            {
              request,
              config: this.config.completion.debounce,
              responseTime: this.completionProviderStats.windowed().stats.averageResponseTime
            },
            options
          );
          const requestId = v4();
          stats.requestSent = true;
          requestStartedAt = performance.now();
          try {
            if (!this.api) {
              throw new Error("http client not initialized");
            }
            const requestPath = "/v1/completions";
            const requestOptions = {
              body: {
                language: request.language,
                segments,
                user: this.auth?.user
              },
              signal: this.createAbortSignal({ signal })
            };
            this.logger.debug(
              { requestId, requestOptions, url: this.config.server.endpoint + requestPath },
              "Completion request"
            );
            const response = await this.api.POST(requestPath, requestOptions);
            if (response.error || !response.response.ok) {
              throw new HttpError(response.response);
            }
            this.logger.debug({ requestId, response }, "Completion response");
            const responseData = response.data;
            stats.requestLatency = performance.now() - requestStartedAt;
            completionResponse = {
              id: responseData.id,
              choices: responseData.choices.map((choice) => {
                return {
                  index: choice.index,
                  text: choice.text,
                  replaceRange: {
                    start: request.position,
                    end: request.position
                  }
                };
              })
            };
          } catch (error) {
            if (isCanceledError(error)) {
              this.logger.debug({ requestId, error }, "Completion request canceled");
              stats.requestCanceled = true;
              stats.requestLatency = performance.now() - requestStartedAt;
            } else if (isTimeoutError(error)) {
              this.logger.debug({ requestId, error }, "Completion request timeout");
              stats.requestTimeout = true;
              stats.requestLatency = NaN;
            } else {
              this.logger.error({ requestId, error }, "Completion request failed with unknown error");
              this.healthCheck();
            }
            throw error;
          }
          completionResponse = await preCacheProcess(context, this.config.postprocess, completionResponse);
          if (signal.aborted) {
            throw signal.reason;
          }
          this.completionCache.buildCache(context, JSON.parse(JSON.stringify(completionResponse)));
        }
      }
      completionResponse = await postCacheProcess(context, this.config.postprocess, completionResponse);
      if (signal.aborted) {
        throw signal.reason;
      }
    } catch (error) {
      if (isCanceledError(error) || isTimeoutError(error)) {
        if (stats) {
          stats.aborted = true;
        }
      } else {
        stats = void 0;
      }
      throw error;
    } finally {
      if (stats) {
        this.completionProviderStats.add(stats);
        if (stats.requestSent && !stats.requestCanceled) {
          const windowedStats = this.completionProviderStats.windowed();
          const checkResult = this.completionProviderStats.check(windowedStats);
          switch (checkResult) {
            case "healthy":
              this.popIssue("slowCompletionResponseTime");
              this.popIssue("highCompletionTimeoutRate");
              break;
            case "highTimeoutRate":
              this.popIssue("slowCompletionResponseTime");
              this.pushIssue("highCompletionTimeoutRate");
              break;
            case "slowResponseTime":
              this.popIssue("highCompletionTimeoutRate");
              this.pushIssue("slowCompletionResponseTime");
              break;
          }
        }
      }
    }
    this.logger.trace({ context, completionResponse }, "Return from provideCompletions");
    return completionResponse;
  }
  async postEvent(request, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.completionProviderStats.addEvent(request.type);
    const requestId = v4();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1/events";
      const requestOptions = {
        body: request,
        params: {
          query: {
            select_kind: request.select_kind
          }
        },
        signal: this.createAbortSignal(options),
        parseAs: "text"
      };
      this.logger.debug({ requestId, requestOptions, url: this.config.server.endpoint + requestPath }, "Event request");
      const response = await this.api.POST(requestPath, requestOptions);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.debug({ requestId, response }, "Event response");
      return true;
    } catch (error) {
      if (isTimeoutError(error)) {
        this.logger.debug({ requestId, error }, "Event request timeout");
      } else if (isCanceledError(error)) {
        this.logger.debug({ requestId, error }, "Event request canceled");
      } else {
        this.logger.error({ requestId, error }, "Event request failed with unknown error");
      }
      return false;
    }
  }
};
_TabbyAgent.tryConnectInterval = 1e3 * 30;
_TabbyAgent.submitStatsInterval = 1e3 * 60 * 60 * 24;
var TabbyAgent = _TabbyAgent;

// src/Agent.ts
var agentEventNames = [
  "statusChanged",
  "configUpdated",
  "authRequired",
  "issuesUpdated"
];

export { TabbyAgent, agentEventNames };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.mjs.map